#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=AutoIt_Old4.ico
#AutoIt3Wrapper_UseUpx=n
;#AutoIt3Wrapper_UseAnsi=y ; for v3.2
#AutoIt3Wrapper_Res_Comment=compiled by argumentum with Autoit v3.2.12.1 ANSI, should run on Win95C onwards without problems.                https://www.autoitscript.com/forum/topic/10534-wmi-scriptomatic-tool-for-autoit/?do=findComment&comment=1243336
#AutoIt3Wrapper_Res_Description=Tool to generate WMI code for AutoIt3.
#AutoIt3Wrapper_Res_Fileversion=0.2015.11.28
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=C:\Program Files (x86)\AutoIt3\Aut2Exe\Icons\AutoIt_Main_v10_256x256_RGB-A.ico ; for v3.3
#AutoIt3Wrapper_Res_Comment=compiled by argumentum with Autoit v3.3.12.1                https://www.autoitscript.com/forum/topic/10534-wmi-scriptomatic-tool-for-autoit/?do=findComment&comment=1243336 ; for v3.3
#AutoIt3Wrapper_Run_Au3Stripper=y ; for v3.3
#pragma compile(AutoItExecuteAllowed, true) ; for v3.3

#cs ----------------------------------------------------------------------------

	AutoIt Version: 3.2.12.1

#ce ----------------------------------------------------------------------------

Local $isAnsiStr = "", $isAdminStr = "[User]"
;If @AutoItVersion = "3.2.12.1" Then $isAnsiStr = "[ANSI]" ; for v3.2
If IsAdmin() Then $isAdminStr = "[Admin]"
Local $sTitle = "AutoIt ScriptOMatic Tool  [" & getSelfVersionForTitle() & "]" & $isAnsiStr & $isAdminStr

If $CmdLine[0] > 0 Then
	If $CmdLine[1] = "/Scite" Then ; free ScITE from waiting for this app. to finish ( if misconfigured )
		If WinExists($sTitle) Then ; also make sure to run just one instance
			WinActivate($sTitle)
		Else
			Run(@ScriptFullPath)
		EndIf
		Exit 0
	EndIf
EndIf

;~ Exit make_a_function_for_ScriptOMatic()
Func make_a_function_for_ScriptOMatic()
	Local $s = ClipGet() ; copy the real, working, tidy'ed func into clipboard to get it from for process.
	$s = StringReplace($s, @TAB, "$TAB&")
	Local $n, $i, $a = StringSplit($s, @CRLF, 1)
	$s = "Func Func_to_string_OfThis( $TAB = '   ' )" & @CRLF
	$s &= 'Local $sOut = ""&@CRLF' & @CRLF
	For $n = 1 To $a[0]
		If $a[$n] = "" Then ContinueLoop
		$i = StringInStr($a[$n], "$TAB&", 0, -1)
		If $i Then
			If Not StringInStr($a[$n], "'") Then
				$a[$n] = StringLeft($a[$n], $i + 4) & "'" & StringTrimLeft($a[$n], $i + 4) & "'&@CRLF"
			Else
				If StringInStr($a[$n], '"') Then $a[$n] = StringReplace($a[$n], '"', '""')
				$a[$n] = StringLeft($a[$n], $i + 4) & '"' & StringTrimLeft($a[$n], $i + 4) & '"&@CRLF'
			EndIf
		Else
			$a[$n] = "'" & $a[$n] & "'&@CRLF"
		EndIf
		$s &= '$sOut &= ' & $a[$n] & @CRLF
	Next
	ConsoleWrite(@CRLF & @CRLF & $s & 'Return $sOut' & @CRLF & "EndFunc" & @CRLF & @CRLF) ; write the "ScriptOMatic string" function to console ( and fix any errors by hand ;)
EndFunc   ;==>make_a_function_for_ScriptOMatic


; AutoIt ScriptOMatic
; -------------------
;
; AutoIt's counterpart of Microsoft's Scriptomatic
;
; Author:		SvenP
; Date/version:	2005-04-17
; See also:		http://www.microsoft.com/technet/scriptcenter/tools/scripto2.mspx
; Requires:		AutoIt beta version 3.1.1.8 or higher (COM support!!)
;
; GUI generated by AutoBuilder 0.5 Prototype

; mod. by argumentum on 2015.05.01 to display the output as array <-- initial mod., find the history at the link.
; http://www.autoitscript.com/forum/topic/10534-wmi-scriptomatic-tool-for-autoit/?page=5#comment-1243336


Opt("GUICloseOnESC", 0)
Opt("MustDeclareVars", 1)

#include <GuiConstantsEx.au3>
#include <WindowsConstants.au3>
#include <SendMessage.au3>
#include <Misc.au3>
#include <Array.au3>
#include <GUIComboBox.au3>

#include <GuiConstantsEx.au3>
#include <GuiListView.au3>

#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <GuiStatusBar.au3>

#include "ScriptOMatic.Sci.au3"

Global $Scite_WM_COPYDATA
;Global Const $WM_COPYDATA = 0x004A

Global $_iWMI_oWMIError = ObjEvent("AutoIt.Error", "_iWMI_ErrorHandler") ; COM error handler.

; ************************
; * Global State Variables
; ************************
Global $g_sCurrentNamespace = "\root\CIMV2"
Global $g_iCurrentNamespaceIndex = 0
Global $g_sWMISource = "." ; "localhost"
Global $g_sOutputFormat = "Array"

; ************************
; * Main GUI
; ************************
Global $ini = @AppDataDir & '\ScriptOMaticForAutoIt3\ScriptOMatic.ini'
Global $sCacheFileBaseName = StringTrimRight($ini, 3) & "cache."
If FileExists(@ScriptDir & '\ScriptOMatic.ini') Then ; it's a portable install
	$ini = @ScriptDir & '\ScriptOMatic.ini'
	$sCacheFileBaseName = @ScriptDir & "\cache\ScriptOMatic.cache."
	If Not FileExists(@ScriptDir & '\cache') Then DirCreate(@ScriptDir & '\cache')
EndIf
If Not FileExists($ini) Then $sCacheFileBaseName = @TempDir & "\ScriptOMatic.cache." ; this way, when in portable mode( and no personal .ini, just the .exe ) is a clean exit ( if so you choose to )
Global $iTab = Int(IniRead($ini, "Settings", "g_idAST_ScriptCode_Tab", "4"))
Global $sTab = tabInt2Str($iTab)
Global $a2h_td1 = IniRead($ini, "Settings", "array2html_bg1", 'bgcolor="#EAEAEA"')
Global $a2h_td2 = IniRead($ini, "Settings", "array2html_bg2", 'bgcolor="#E2E2E2"') ; #0080C0  #E2E2E2
Global $sett_RemoveTempFiles = Int(IniRead($ini, "Settings", "sett_RemoveTempFiles", 0))
Global $_ArrayDisplay_Override_Topmost = Int(IniRead($ini, "Settings", "ArrayDisplay_Override_Topmost", 0))
Global $_ArrayDisplay_Override_PreferredMonitor = Int(IniRead($ini, "Settings", "ArrayDisplay_Override_PreferredMonitor", 0))
Global $sSaveFile_InitDir = IniRead($ini, "Settings", "SaveFile_InitDir", @ScriptDir)
Global $sGoogleIt = IniRead($ini, "Settings", "sGoogleIt", "https://www.google.com/search?q=wmi+%22@SelectedClass%22+example+vbs")
Global $ShowOnlyDynamicClasses = Int(IniRead($ini, "Settings", "ShowOnlyDynamicClasses", 1))
Global $iArrayDefaultLimit = Int(IniRead($ini, "Settings", "iArrayDefaultLimit", 1000))
Global $iSep = Chr(1) ; for $aRemotePCs, it will be saved to INI in a StringToBinary ( to avoid plain text snooping )
Global $aRemotePCs, $gd_ComputerName, $gd_UserName, $gd_UserPassword
loadRemotePCs()
Global $aUserEditor[3]
$aUserEditor[0] = 0 ; enabled/ disabled
$aUserEditor[1] = "" ; path to editor
$aUserEditor[2] = "" ; temp for preview
If IniRead($ini, "Settings", "Editor", "") <> "" Then
	$aUserEditor[0] = 1
	$aUserEditor[1] = IniRead($ini, "Settings", "Editor", "")
ElseIf IniRead($ini, "Settings", "#~ Editor", "") <> "" Then
	$aUserEditor[0] = 0
	$aUserEditor[1] = IniRead($ini, "Settings", "#~ Editor", "")
EndIf

Global $sHelpString = @CRLF & "use F5 to run the code." & @CRLF & "Ctrl-F11 changes font size, Ctrl-Q to quit, etc." & @CRLF & "Ctrl-A,C,V,Z,X to copy,paste,etc."
$sHelpString &= @CRLF & @CRLF & 'clicking the Array Radio will cycle between:'
$sHelpString &= @CRLF & $sTab & 'Array = as default'
$sHelpString &= @CRLF & $sTab & 'arraY = the array but rotated'
$sHelpString &= @CRLF & $sTab & 'Html  = the array to Html'
$sHelpString &= @CRLF & $sTab & 'htmL  = the Html but rotated' & @CRLF
$sHelpString &= @CRLF & 'When a file named "_Array2D_toHtml.au3" is in the folder,'
$sHelpString &= @CRLF & 'it will be used for _Array2D_toHtml() instead of the one built-in' & @CRLF
If @Compiled Then
	$sHelpString &= @CRLF & 'Also, when a file named "Array.au3" is in the current folder,'
	$sHelpString &= @CRLF & 'it will be used to "#include" instead of the one built-in'
EndIf

Global $GUIMINWID = 684, $GUIMINHT = 561 - 250 ;set your restrictions here
GUIRegisterMsg($WM_GETMINMAXINFO, "WM_GETMINMAXINFO")

Global $g_Form = GUICreate($sTitle, 684, 561, (@DesktopWidth - 684) / 2, (@DesktopHeight - 561) / 2, $WS_OVERLAPPEDWINDOW + $WS_VISIBLE + $WS_CLIPSIBLINGS)
Global $id_StatusBar = _GUICtrlStatusBar_Create($g_Form)
_GUICtrlStatusBar_SetText($id_StatusBar,"Autoit v"&@AutoItVersion)

;If @AutoItVersion = "3.2.12.1" Then _mm__CenterOnMonitor($g_Form) ; for v3.2
GUICtrlCreateGroup("", 10, 10, 660, 120)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
Global $g_idWMI_NamespaceLabel = GUICtrlCreateLabel("WMI Namespace", 20, 30, 150, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)

Global $g_idAST_RemotePc = GUICtrlCreateButton("RemotePC", 140, 24, 70, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)

Global $g_idAST_Settings = GUICtrlCreateButton("S&ettings", 220, 24, 80, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)

Global $g_idAST_ScITE_insert = GUICtrlCreateButton("Send to ScITE", 430, 24, 120, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
GUICtrlSetTip(-1, "insert code in ScITE at cursor" & @CR & @CR & "will blink 3 times when" & @CR & "ScITE is not found")

Global $g_idWMI_Namespace = GUICtrlCreateCombo("WMI_Namespaces", 20, 50, 280, 400, BitOR($GUI_SS_DEFAULT_COMBO, $CBS_SIMPLE))
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
GUICtrlCreateLabel("WMI Class", 320, 30, 60, 20)

GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
Global $g_idWMI_Classes = GUICtrlCreateCombo("WMI_Classes", 320, 50, 340 - 20, 400, BitOR($GUI_SS_DEFAULT_COMBO, $CBS_SIMPLE))
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)

Global $g_idAST_FilterChBox = GUICtrlCreateCheckbox("&F", 643, 50, 22, 22, BitOR($GUI_SS_DEFAULT_CHECKBOX, $BS_PUSHLIKE))
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
GUICtrlSetTip(-1, "filter the list with space separated strings" & @CR & "right click for options menu")

Global $g_idAST_FilterStr = ""
Global $g_idAST_FilterInput = GUICtrlCreateInput($g_idAST_FilterStr, 320, 50, 340 - 20, 21)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
GUICtrlSetState($g_idAST_FilterInput, $GUI_HIDE)
Global $g_idAST_Filter_OnOff = 0

Global $g_idAST_Web = GUICtrlCreateButton("&Google it", 560, 24, 100, 20) ; "Lookup on WWW"
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
GUICtrlCreateGroup("", 10, 80, 660, 50)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
Global $g_idAST_Run = GUICtrlCreateButton("&Run", 20, 100, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
GUICtrlSetTip(-1, "press F5 to run / stop temp. script")
Global $idAST_CIMv2 = GUICtrlCreateButton("CI&Mv2", 80, 100, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)

Global $idAST_WMISource = 9999999 ; GUICtrlCreateButton("&WMISource", 140, 100, 70, 20) ; ...not in use anymore as of 2015.5.17
;GUICtrlSetTip(-1, "computer whose WMI repository you want to read from")

Global $idAST_WMI_ArraySelectEntries = GUICtrlCreateButton("Se&lect Prop.", 140, 100, 70, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
GUICtrlSetTip(-1, "Select the properties to pull from WMI" & @CR & "..this is only for the Array genaration")
Global $idAST_Open = GUICtrlCreateButton("&Open", 220, 100, 60, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)

Global $g_idAST_Save = GUICtrlCreateButton("&Save", 290, 100, 60, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)

Local $Save_Dummy = GUICtrlCreateDummy()
Local $Save_Context = GUICtrlCreateContextMenu($Save_Dummy)
Local $Save_Save = GUICtrlCreateMenuItem("Save", $Save_Context)
GUICtrlCreateMenuItem("", $Save_Context)
Local $Save_SaveEdit = GUICtrlCreateMenuItem("Save and Edit", $Save_Context)

GUICtrlSetData($g_idAST_FilterInput, IniRead($ini, "Settings", "Filter", ""))
Local $Filter_Context = GUICtrlCreateContextMenu($g_idAST_FilterChBox)
Local $Filter_Save = GUICtrlCreateMenuItem("Save to file", $Filter_Context)


Local $ScITE_Dummy = GUICtrlCreateDummy()
Local $ScITE_Context = GUICtrlCreateContextMenu($ScITE_Dummy)
Local $ScITE_InsertAtPos = GUICtrlCreateMenuItem("Intert at cursor", $ScITE_Context)
GUICtrlCreateMenuItem("", $ScITE_Context)
Local $ScITE_InsertInNew = GUICtrlCreateMenuItem("Copy to new tab", $ScITE_Context)


Local $idAST_Quit = GUICtrlCreateButton("&Quit", 360, 100, 60, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
GUICtrlCreateGroup("Output", 430, 80, 240, 50)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
Global $g_idAST_RadioDialog = GUICtrlCreateRadio("&Dialog", 440, 100, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
Global $g_idAST_RadioText = GUICtrlCreateRadio("&Text", 500, 100, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
GUICtrlSetTip(-1, "double-click the radio button to load the TXT file" & @CR & "from a prior or interrupted dump.")
Global $g_idAST_RadioHTML = GUICtrlCreateRadio("&HTML", 550, 100, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
GUICtrlSetTip(-1, "double-click the radio button to load the HTML file" & @CR & "from a prior or interrupted dump.")
Global $g_idAST_RadioArray = GUICtrlCreateRadio("Arra&y", 610, 100, 50, 20)
GUICtrlSetTip(-1, "keep clicking to change output options")
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)

Global $g_idAST_ScriptCode = 0
Global $aSciLexer = __SciLexer_Create($g_Form, 10, 140, 661, 390)

If @error Then
;~ 	$Edit1 = GUICtrlCreateEdit("", 8, 40, 593, 361)
	$g_idAST_ScriptCode = GUICtrlCreateEdit("One moment..." & IsAdmin_ForHelpStr() & @CRLF & $sHelpString, 10, 140, 661, 390)
	GUICtrlSetData(-1, "Edit1")
	GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKBOTTOM)
	GUIRegisterMsg($WM_SIZE, "WM_SIZE")
Else
	GUIRegisterMsg($WM_SIZE, "WM_SIZE")
	__SciLexer_SetData($aSciLexer[0], "One moment..." & IsAdmin_ForHelpStr() & @CRLF & $sHelpString)
EndIf


Global $g_idAST_ScriptCodeFont
Global $g_idAST_ScriptCode_bg = Int(IniRead($ini, "Settings", "g_idAST_ScriptCode_bg", 0xE9E9E9))
_fontGetIni($g_idAST_ScriptCodeFont, "g_idAST_ScriptCode_font")
_fontCtrlSet($g_idAST_ScriptCodeFont, $g_idAST_ScriptCode, 1)
GUICtrlSetBkColor($g_idAST_ScriptCode, $g_idAST_ScriptCode_bg)

GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKBOTTOM)

Global $cF5 = GUICtrlCreateButton("$cF5", 1, 1, 1, 1)
GUICtrlSetState($cF5, $GUI_HIDE)

Global $cEscape = GUICtrlCreateButton("$cEscape", 1, 1, 1, 1)
GUICtrlSetState($cEscape, $GUI_HIDE)

Global $copyCodeInEdit = GUICtrlCreateButton("$copyCodeInEdit", 1, 1, 1, 1)
GUICtrlSetState($copyCodeInEdit, $GUI_HIDE)

Global $overrideFont = GUICtrlCreateButton("$overrideFont", 1, 1, 1, 1)
GUICtrlSetState($overrideFont, $GUI_HIDE)

Global $cTab = GUICtrlCreateButton("$overrideFont", 1, 1, 1, 1)
GUICtrlSetState($cTab, $GUI_HIDE)

Global $copyCodeInEdit = GUICtrlCreateButton("$copyCodeInEdit", 1, 1, 1, 1)
GUICtrlSetState($copyCodeInEdit, $GUI_HIDE)

GUICtrlSetState($idAST_CIMv2, $GUI_DISABLE)

GUICtrlSetState_idAST_Radio(1) ; DISABLE



GUISetState()

Func IsAdmin_ForHelpStr()
	If IsAdmin() Then
		Return "  ( you have Administrator rights )"
	Else
		Return "  ( you don't have Administrator rights )"
	EndIf
EndFunc   ;==>IsAdmin_ForHelpStr

Func GUICtrlSetData_Sci($unused, $sData, $sDefault = "")
	If $g_idAST_ScriptCode Then
		GUICtrlSetData($g_idAST_ScriptCode, $sData, $sDefault)
	Else
		__SciLexer_SetData($aSciLexer[0], $sData)
		_Sci_EmptyUndoBuffer($aSciLexer[0])
	EndIf
EndFunc   ;==>GUICtrlSetData_Sci

Func GUICtrlRead_Sci($g_idAST_ScriptCode)
	If $g_idAST_ScriptCode Then
		Return GUICtrlRead($g_idAST_ScriptCode)
	Else
		Return _Sci_GetText($aSciLexer[0])
	EndIf
EndFunc   ;==>GUICtrlRead_Sci



; Initial GUI Settings
GUICtrlSetState($g_idAST_Settings, $GUI_DISABLE)
GUICtrlSetState($g_idAST_Web, $GUI_DISABLE)
GUICtrlSetState($g_idAST_ScITE_insert, $GUI_DISABLE)
GUICtrlSetState($g_idAST_Run, $GUI_DISABLE)
GUICtrlSetState($idAST_WMI_ArraySelectEntries, $GUI_DISABLE)
GUICtrlSetState($g_idAST_Save, $GUI_DISABLE)
GUICtrlSetState($g_idAST_RadioArray, $GUI_CHECKED)
GUICtrlSetState($g_idWMI_Namespace, $GUI_DISABLE)
GUICtrlSetState($g_idWMI_Classes, $GUI_DISABLE)

; Fill the WMI_Namespaces Combobox
Global $sNamespacesCombo = ""
Global $iNamespacesComboLimited = 0
Global $iClassesComboError = 1
LoadWMINamespaces()

; Fill the WMI_Classes Combobox
If GUICtrlRead($g_idWMI_Namespace) = "" Then
	If IsAdmin() Then
		GUICtrlSetData_Sci($g_idAST_ScriptCode, @CRLF & @CRLF & $sTab & "winmgmts failed.")
	Else
		GUICtrlSetData_Sci($g_idAST_ScriptCode, @CRLF & @CRLF & $sTab & "winmgmts failed." & @CRLF & @CRLF & $sTab & 'try "Run as administrator"')
	EndIf
	GUICtrlSetState($idAST_CIMv2, $GUI_DISABLE)
	GUICtrlSetState($idAST_Open, $GUI_DISABLE)
	GUICtrlSetState($idAST_WMISource, $GUI_DISABLE)
	GUICtrlSetState($g_idWMI_Namespace, $GUI_DISABLE)
	GUICtrlSetState($g_idWMI_Classes, $GUI_DISABLE)
Else
	If $iNamespacesComboLimited Then
		$sHelpString &= @CRLF & @CRLF & $sTab & "winmgmts failed to list all Namespaces." & @CRLF & $sTab & 'try "Run as administrator"'
	EndIf
	HandleNamespaceChange()
EndIf
Local $copyCodeInEditAccelKeys = "^a" ; quickNdity fix
If $aSciLexer[0] Then $copyCodeInEditAccelKeys = "^\"
Local $aAccelKeys[15][2] = [["{F5}", $cF5],[$copyCodeInEditAccelKeys, $copyCodeInEdit],["^q", $idAST_Quit], _
		["^{F11}", $overrideFont],["^o", $idAST_Open],["^s", $g_idAST_Save],["^w", $idAST_WMISource],["^t", $cTab], _
		["^m", $idAST_CIMv2],["^r", $g_idAST_Run],["^g", $g_idAST_Web],["^y", $g_idAST_RadioArray],["{ESC}", $cEscape],["^e", $g_idAST_Settings],["^\", $g_idAST_RemotePc]]
GUISetAccelerators($aAccelKeys)

If @Compiled Then
;	;	If @AutoItVersion = "3.2.12.1" Then ; for v3.2 start
;	FileDelete(@TempDir & "\Array.au3")
;	If FileExists(@ScriptDir & "\Array.au3") Then
;		FileCopy(@ScriptDir & "\Array.au3", @TempDir & "\Array.au3")
;	Else
;		FileInstall("..\..\AutoIt3_[3.2.12.1]\Include\Array.au3", @TempDir & "\Array.au3") ; G:\au3forum\Scriptomatic(2015.05.04)\ANSI\AutoIt3\Include
;	EndIf
;	;	Else ; you are using a more curent version, then:  ; for v3.2 end
	;	;  ; for v3.3 start
		FileDelete(@TempDir & "\Array.au3")
		FileDelete(@TempDir & "\AutoItConstants.au3")
		FileDelete(@TempDir & "\MsgBoxConstants.au3")
		FileDelete(@TempDir & "\StringConstants.au3")
		If FileExists(@ScriptDir & "\Array.au3") Then
			FileCopy(@ScriptDir & "\Array.au3", @TempDir & "\Array.au3")
			FileCopy(@ScriptDir & "\AutoItConstants.au3", @TempDir & "\AutoItConstants.au3")
			FileCopy(@ScriptDir & "\MsgBoxConstants.au3", @TempDir & "\MsgBoxConstants.au3")
			FileCopy(@ScriptDir & "\StringConstants.au3", @TempDir & "\StringConstants.au3")
		Else
			FileInstall("C:\Program Files (x86)\AutoIt3\Include\Array.au3", @TempDir & "\Array.au3")
			FileInstall("C:\Program Files (x86)\AutoIt3\Include\AutoItConstants.au3", @TempDir & "\AutoItConstants.au3")
			FileInstall("C:\Program Files (x86)\AutoIt3\Include\MsgBoxConstants.au3", @TempDir & "\MsgBoxConstants.au3")
			FileInstall("C:\Program Files (x86)\AutoIt3\Include\StringConstants.au3", @TempDir & "\StringConstants.au3")
		EndIf
	;	;  ; for v3.3 end
;	;	EndIf ; for v3.2
EndIf

Global $iCreatedTempFiles = 0
;Opt("OnExitFunc", "OnAutoIt_Exit") ; for v3.2
OnAutoItExitRegister("OnAutoIt_Exit") ; for v3.3

Global $iRotateArray = 0
Local $iMsg, $n
Local $iPid = 0
Local $SEC = @SEC
Global $LookForAutoItTimer = 1
Global $LookForAutoItErrorWindow = 0
Global $LookForAutoItDialog = ""
Local $i_idAST_Radio = $g_idAST_RadioArray
GUICtrlSetState($idAST_CIMv2, $GUI_ENABLE)
GUICtrlSetState($g_idWMI_Namespace, $GUI_ENABLE)
GUICtrlSetState($g_idWMI_Classes, $GUI_ENABLE)
Local $t_idAST_RadioText = TimerInit()
Local $t_idAST_RadioHTML = TimerInit()
Global $iWMI_ArraySelectEntriesMode = 0
Global $hWMI_ArraySelectEntries = 0
Global $aWMI_ArraySelectEntries[1][2]
$aWMI_ArraySelectEntries[0][0] = -1
Global $gWMI_ArraySelectEntries = 0

GUICtrlSetState($g_idAST_Settings, $GUI_ENABLE)
GUICtrlSetState_idAST_Radio(0) ; ENABLE
Func GUICtrlSetState_idAST_Radio($i = 0)
	If $i Then
		GUICtrlSetState($g_idAST_RadioDialog, $GUI_DISABLE)
		GUICtrlSetState($g_idAST_RadioArray, $GUI_DISABLE)
		GUICtrlSetState($g_idAST_RadioHTML, $GUI_DISABLE)
		GUICtrlSetState($g_idAST_RadioText, $GUI_DISABLE)
	Else
		GUICtrlSetState($g_idAST_RadioDialog, $GUI_ENABLE)
		GUICtrlSetState($g_idAST_RadioArray, $GUI_ENABLE)
		GUICtrlSetState($g_idAST_RadioHTML, $GUI_ENABLE)
		GUICtrlSetState($g_idAST_RadioText, $GUI_ENABLE)
	EndIf
EndFunc   ;==>GUICtrlSetState_idAST_Radio

While 1
	$iMsg = GUIGetMsg()
	Switch $iMsg
		Case 0
			If Not $iPid Then ContinueLoop

		Case $GUI_EVENT_RESTORE, $GUI_EVENT_MAXIMIZE, $GUI_EVENT_RESIZED
			__SciLexer_Resize()

		Case $GUI_EVENT_CLOSE
			;	If GUICtrlRead($g_idAST_Run) = "STOP" Then ContinueLoop
			ExitLoop

		Case $idAST_Quit
			ExitLoop

		Case $g_idAST_Settings
			If GUICtrlRead($g_idAST_Run) = "STOP" Then ; for debugging, go figure, you may like the idea.
				GUICtrlSetData($g_idAST_Settings, "edit tmp. file")
				GUICtrlSetState($g_idAST_Settings, $GUI_DISABLE)
				ShellExecute(@TempDir & "\ScriptOMatic.temp.au3", "", @TempDir, "Edit")
				Sleep(200)
				GUICtrlSetData($g_idAST_Settings, "S&ettings")
				GUICtrlSetState($g_idAST_Settings, $GUI_ENABLE)
				ContinueLoop
			EndIf
			GUICtrlSetState($g_idAST_Settings, $GUI_DISABLE)
			setSettings($g_Form)
			HandleOutputChange()
			GUICtrlSetState($g_idAST_Settings, $GUI_ENABLE)

		Case $g_idAST_RemotePc
			GUICtrlSetState($g_idAST_RemotePc, $GUI_DISABLE)
			setRemotePCs($g_Form)
			HandleOutputChange()
			GUICtrlSetState($g_idAST_RemotePc, $GUI_ENABLE)

		Case $copyCodeInEdit
			_GUICtrl_Edit_SetSel($g_idAST_ScriptCode, 0, -1)

		Case $g_idAST_FilterInput
			Send("!f")

		Case $g_idAST_FilterChBox
			If Int(GUICtrlRead($g_idAST_FilterChBox)) = 1 Then
				GUICtrlSetState($g_idWMI_Classes, $GUI_HIDE)
				GUICtrlSetState($g_idAST_FilterInput, $GUI_SHOW)
				GUICtrlSetState($g_idAST_FilterInput, $GUI_FOCUS)
			Else
				GUICtrlSetState($g_idAST_FilterInput, $GUI_DISABLE)
				GUICtrlSetData($g_idAST_FilterInput, StringStripWS(GUICtrlRead($g_idAST_FilterInput), 7))
				filterClassesCombo(GUICtrlRead($g_idAST_FilterInput))
				GUICtrlSetState($g_idAST_FilterInput, $GUI_HIDE)
				GUICtrlSetState($g_idWMI_Classes, $GUI_SHOW)
				GUICtrlSetState($g_idAST_FilterInput, $GUI_ENABLE)
				_GUICtrlComboBox_ShowDropDown($g_idWMI_Classes, True)
				GUICtrlSetState($g_idWMI_Classes, $GUI_FOCUS)
			EndIf

		Case $overrideFont
			$g_idAST_ScriptCodeFont[3] = $g_idAST_ScriptCodeFont[3] + 2
			If $g_idAST_ScriptCodeFont[3] > 17 Then $g_idAST_ScriptCodeFont[3] = 8
			_fontCtrlSet($g_idAST_ScriptCodeFont, $g_idAST_ScriptCode, 1)

		Case $cTab
			$iTab += 1
			If $iTab > 12 Then $iTab = 0
			$sTab = tabInt2Str($iTab)
			If StringInStr(GUICtrlRead_Sci($g_idAST_ScriptCode), "Generated by AutoIt ScriptOMatic") Then
				HandleOutputChange()
			Else
				redrawHelpStr()
			EndIf

		Case $g_idAST_ScITE_insert
			GUICtrlSetState($g_idAST_ScITE_insert, $GUI_DISABLE)
			ShowMenu($g_Form, $iMsg, $ScITE_Context)
			GUICtrlSetState($g_idAST_ScITE_insert, $GUI_ENABLE)
			GUICtrlSetState($g_idWMI_NamespaceLabel, $GUI_FOCUS)

		Case $ScITE_InsertAtPos
			GUICtrlSetState($g_idAST_ScITE_insert, $GUI_DISABLE)
			If _InsertIntoScite(GUICtrlRead_Sci($g_idAST_ScriptCode), 0) Then
				GUICtrlSetData($g_idAST_ScITE_insert, "No ScITE window")
				For $n = 1 To 3
					GUICtrlSetState($g_idAST_ScITE_insert, $GUI_ENABLE)
					Sleep(400)
					GUICtrlSetState($g_idAST_ScITE_insert, $GUI_DISABLE)
					Sleep(400)
				Next
				GUICtrlSetData($g_idAST_ScITE_insert, "Send to ScITE")
			Else
				Sleep(400)
			EndIf
			GUICtrlSetState($g_idAST_ScITE_insert, $GUI_ENABLE)
			GUICtrlSetState($g_idWMI_NamespaceLabel, $GUI_FOCUS)

		Case $ScITE_InsertInNew
			GUICtrlSetState($g_idAST_ScITE_insert, $GUI_DISABLE)
			If _InsertIntoScite(GUICtrlRead_Sci($g_idAST_ScriptCode), 1) Then
				GUICtrlSetData($g_idAST_ScITE_insert, "No ScITE window")
				For $n = 1 To 3
					GUICtrlSetState($g_idAST_ScITE_insert, $GUI_ENABLE)
					Sleep(400)
					GUICtrlSetState($g_idAST_ScITE_insert, $GUI_DISABLE)
					Sleep(400)
				Next
				GUICtrlSetData($g_idAST_ScITE_insert, "Send to ScITE")
			Else
				Sleep(400)
			EndIf
			GUICtrlSetState($g_idAST_ScITE_insert, $GUI_ENABLE)
			GUICtrlSetState($g_idWMI_NamespaceLabel, $GUI_FOCUS)

		Case $idAST_WMI_ArraySelectEntries
			If $iWMI_ArraySelectEntriesMode = 0 Then
				If $g_idAST_ScriptCode Then GUICtrlSetState($g_idAST_ScriptCode, $GUI_HIDE)
				If $aSciLexer[0] Then __SciLexer_Resize(128) ; GUICtrlSetState($aSciLexer[0], $GUI_HIDE)
				WMI_ArraySelectEntries_DisEnable(1)
				WMI_ArraySelectEntries_Choose($aWMI_ArraySelectEntries)
				$iWMI_ArraySelectEntriesMode = 1
			Else
				WMI_ArraySelectEntries_ReBuild($aWMI_ArraySelectEntries)
				If $g_idAST_ScriptCode Then GUICtrlSetState($g_idAST_ScriptCode, $GUI_SHOW)
				If $aSciLexer[0] Then __SciLexer_Resize(64) ; GUICtrlSetState($aSciLexer[0], $GUI_SHOW)
				GUICtrlDelete($hWMI_ArraySelectEntries)
				$hWMI_ArraySelectEntries = 0
				$iWMI_ArraySelectEntriesMode = 0
				WMI_ArraySelectEntries_DisEnable(0)
			EndIf

		Case $g_idWMI_Namespace
			GUICtrlSetState_idAST_Radio(1)
			GUICtrlSetState($g_idAST_ScITE_insert, $GUI_DISABLE)
			GUICtrlSetState($g_idAST_Web, $GUI_DISABLE)
			GUICtrlSetState($g_idAST_Run, $GUI_DISABLE)
			GUICtrlSetState($idAST_WMI_ArraySelectEntries, $GUI_DISABLE)
			GUICtrlSetState($idAST_CIMv2, $GUI_DISABLE)
			GUICtrlSetState($g_idWMI_Namespace, $GUI_DISABLE)
			GUICtrlSetState($g_idWMI_Classes, $GUI_DISABLE)
			HandleNamespaceChange()
			HandleNamespaceChange()
			GUICtrlSetState($g_idWMI_Namespace, $GUI_ENABLE)
			GUICtrlSetState($g_idWMI_Classes, $GUI_ENABLE)
			GUICtrlSetState($idAST_CIMv2, $GUI_ENABLE)
			GUICtrlSetState_idAST_Radio(0)

		Case $g_idWMI_Classes
			ComposeCode()

		Case $g_idAST_Web
			If GUICtrlGetState($iMsg) = 144 Then ContinueLoop
			GUICtrlSetState($g_idAST_Web, $GUI_DISABLE)
			LookupWeb()
			Sleep(200)
			GUICtrlSetState($g_idAST_Web, $GUI_ENABLE)

		Case $cEscape
			If GUICtrlRead($g_idAST_Run) = "STOP" Then
				If $iPid Then ProcessClose($iPid)
				$SEC = "not the same @SEC"
			EndIf

		Case $Filter_Save
			IniWrite($ini, "Settings", "Filter", StringStripWS(GUICtrlRead($g_idAST_FilterInput), 7))

		Case $cF5
			If GUICtrlRead($g_idAST_Run) = "&Run" Then
				If GUICtrlGetState($g_idAST_Run) = 144 Then ContinueLoop
				Func_g_idAST_Run()
			EndIf

		Case $g_idAST_Run
			If GUICtrlGetState($iMsg) = 144 Then ContinueLoop
			Func_g_idAST_Run()

		Case $g_idAST_Save
			If GUICtrlGetState($iMsg) = 144 Then ContinueLoop
			ShowMenu($g_Form, $iMsg, $Save_Context)

		Case $Save_Save
			SaveScript(0)

		Case $Save_SaveEdit
			SaveScript(1)

		Case $idAST_Open
			If GUICtrlGetState($iMsg) = 144 Then ContinueLoop
			OpenScript()

		Case $idAST_CIMv2
			If GUICtrlGetState($iMsg) = 144 Then ContinueLoop
			GUICtrlSetState($g_idAST_Run, $GUI_DISABLE)
			GUICtrlSetState($idAST_WMI_ArraySelectEntries, $GUI_DISABLE)
			GUICtrlSetState($g_idAST_ScITE_insert, $GUI_DISABLE)
			GUICtrlSetState($g_idAST_Web, $GUI_DISABLE)
			GUICtrlSetState($g_idWMI_Namespace, $GUI_DISABLE)
			GUICtrlSetState($g_idWMI_Classes, $GUI_DISABLE)
			GUICtrlSetState($idAST_CIMv2, $GUI_DISABLE)
			SetNamespaceToCIMV2()
			GUICtrlSetState($idAST_CIMv2, $GUI_ENABLE)
			GUICtrlSetState($g_idWMI_Namespace, $GUI_ENABLE)
			GUICtrlSetState($g_idWMI_Classes, $GUI_ENABLE)

		Case $idAST_WMISource
			If GUICtrlGetState($iMsg) = 144 Then ContinueLoop
			GUICtrlSetState($g_idAST_Web, $GUI_DISABLE)
			GUICtrlSetState($g_idAST_ScITE_insert, $GUI_DISABLE)
			SetWMIRepository()

		Case $g_idAST_RadioDialog, $g_idAST_RadioText, $g_idAST_RadioHTML, $g_idAST_RadioArray
			If TimerDiff($t_idAST_RadioHTML) < 500 Then
				GUICtrlSetState($g_idAST_RadioHTML, $GUI_DISABLE)
				If FileExists(@TempDir & '\ScriptOMatic.' & GUICtrlReadStripExtra($g_idWMI_Classes) & '.htm') Then
					Run(@ComSpec & " /c start " & @TempDir & '\ScriptOMatic.' & GUICtrlReadStripExtra($g_idWMI_Classes) & '.htm', @TempDir, @SW_HIDE)
				Else
					Sleep(500)
					GUICtrlSetState($g_idAST_RadioHTML, $GUI_ENABLE)
					ContinueLoop
				EndIf
				Sleep(2000)
				GUICtrlSetState($g_idAST_RadioHTML, $GUI_ENABLE)
				ContinueLoop
			EndIf
			If TimerDiff($t_idAST_RadioText) < 500 Then
				GUICtrlSetState($g_idAST_RadioText, $GUI_DISABLE)
				If FileExists(@TempDir & '\ScriptOMatic.' & GUICtrlReadStripExtra($g_idWMI_Classes) & '.txt') Then
					Run(@ComSpec & " /c start " & @TempDir & '\ScriptOMatic.' & GUICtrlReadStripExtra($g_idWMI_Classes) & '.txt', @TempDir, @SW_HIDE)
				Else
					Sleep(500)
					GUICtrlSetState($g_idAST_RadioText, $GUI_ENABLE)
					ContinueLoop
				EndIf
				Sleep(2000)
				GUICtrlSetState($g_idAST_RadioText, $GUI_ENABLE)
				ContinueLoop
			EndIf
			If $iMsg = $g_idAST_RadioArray And $i_idAST_Radio = $g_idAST_RadioArray Then
				RotateArray_nextCount()
				Switch $iRotateArray
					Case 0
						GUICtrlSetData($g_idAST_RadioArray, "Arra&y")
					Case 1
						GUICtrlSetData($g_idAST_RadioArray, "arra&Y")
					Case 2
						GUICtrlSetData($g_idAST_RadioArray, "Htm&l")
					Case 3
						GUICtrlSetData($g_idAST_RadioArray, "htm&L")
				EndSwitch
			EndIf
			$i_idAST_Radio = $iMsg
			HandleOutputChange()
			If $iMsg = $g_idAST_RadioHTML Then $t_idAST_RadioHTML = TimerInit()
			If $iMsg = $g_idAST_RadioText Then $t_idAST_RadioText = TimerInit()

	EndSwitch

	; this here is to stop the temp.au3 if you feel you must.
	If Not $iPid Then ContinueLoop
;	;If @AutoItVersion = "3.2.12.1" Then ; for v3.2 start
;	If TimerDiff($LookForAutoItTimer) > 50 Then
;		$LookForAutoItTimer = TimerInit()
;		If $LookForAutoItErrorWindow Then
;			If WinExists("[CLASS:#32770;TITLE:AutoIt Error;]") Then
;				$LookForAutoItErrorWindow = 0
;				_mm__CenterOnMonitor("[CLASS:#32770;TITLE:AutoIt Error;]") ; for v3.2
;			EndIf
;		EndIf
;		If $g_sOutputFormat = "Dialog" Then
;			If WinExists("[CLASS:#32770;TITLE:WMI ScriptOMatic;]") Then
;				If $LookForAutoItDialog <> WinGetHandle("[CLASS:#32770;TITLE:WMI ScriptOMatic;]") Then
;					_mm__CenterOnMonitor("[CLASS:#32770;TITLE:WMI ScriptOMatic;]") ; for v3.2
;					$LookForAutoItDialog = WinGetHandle("[CLASS:#32770;TITLE:WMI ScriptOMatic;]")
;				EndIf
;			EndIf
;		EndIf
;	EndIf
;	;EndIf ; for v3.2 end
	If $SEC = @SEC Then ContinueLoop
	$SEC = @SEC
	If ProcessExists("WerFault.exe") Then WinClose("Tool to generate WMI code for AutoIt3.") ; ..this crash popup is uselessly bothersome
	If ProcessExists($iPid) Then ContinueLoop
	GUICtrlSetData($g_idAST_Run, "&Run")
	$iPid = 0
	FileDelete(@TempDir & "\ScriptOMatic.temp.au3")
	GUICtrlSetState($idAST_CIMv2, $GUI_ENABLE)
	GUICtrlSetState($idAST_WMISource, $GUI_ENABLE)
	GUICtrlSetState($idAST_Open, $GUI_ENABLE)
	GUICtrlSetState($g_idAST_Save, $GUI_ENABLE)
	GUICtrlSetState($idAST_Quit, $GUI_ENABLE)

WEnd

GUIDelete()
Exit 0
ProcessClose(@AutoItPID)

Func OnAutoIt_Exit()

	Local $iCreatedTempFiles_Removem = 0
	Local $exitMethod = @exitMethod
	If $exitMethod = 2 Then
		; don't touch
	Else
		If $exitMethod = 1 Then
			If $sett_RemoveTempFiles = 0 Then
				If $iCreatedTempFiles Then
					Local $iRetMsgBox = MsgBox(4 + 262144 + 32 + 256, "AutoIt ScriptOMatic Tool", "you have created temporary files." & @CR & "would you like to remove them ?", 30)
					If $iRetMsgBox = 6 Then $iCreatedTempFiles_Removem = 1
				EndIf
			EndIf
		EndIf
		If $sett_RemoveTempFiles = 1 Then ; don't ask, just do it
			$iCreatedTempFiles_Removem = 1
		EndIf
	EndIf

	If @Compiled Then
		FileDelete(@TempDir & "\Array.au3")
		FileDelete(@TempDir & "\AutoItConstants.au3") ; for v3.3
		FileDelete(@TempDir & "\MsgBoxConstants.au3") ; for v3.3
		FileDelete(@TempDir & "\StringConstants.au3") ; for v3.3
		Local $n, $aProcessList = ProcessList(@ScriptName)
		For $n = 1 To $aProcessList[0][0]
			If $aProcessList[$n][1] = @AutoItPID Then ContinueLoop
			ProcessClose($aProcessList[$n][1]) ; clean house, just in case.
		Next
	EndIf

	If $iCreatedTempFiles_Removem Then
		FileDelete(@TempDir & '\ScriptOMatic.*.txt')
		FileDelete(@TempDir & '\ScriptOMatic.*.htm')
		FileDelete(@TempDir & '\ScriptOMatic.*.dat')
	EndIf

EndFunc   ;==>OnAutoIt_Exit

Func WMI_ArraySelectEntries_DisEnable($statusDo)
	If UBound($gWMI_ArraySelectEntries) <> 15 Then
		Dim $gWMI_ArraySelectEntries[15][2]
		$gWMI_ArraySelectEntries[0][0] = 14
		$gWMI_ArraySelectEntries[1][0] = $g_idAST_Settings
		$gWMI_ArraySelectEntries[2][0] = $g_idAST_Web
		$gWMI_ArraySelectEntries[3][0] = $g_idAST_ScITE_insert
		$gWMI_ArraySelectEntries[4][0] = $g_idAST_Run
		$gWMI_ArraySelectEntries[5][0] = $g_idAST_RadioDialog
		$gWMI_ArraySelectEntries[6][0] = $g_idAST_RadioText
		$gWMI_ArraySelectEntries[7][0] = $g_idAST_RadioHTML
		$gWMI_ArraySelectEntries[8][0] = $g_idAST_RadioArray
		$gWMI_ArraySelectEntries[9][0] = $g_idWMI_Namespace
		$gWMI_ArraySelectEntries[10][0] = $g_idWMI_Classes
		$gWMI_ArraySelectEntries[11][0] = $g_idAST_FilterChBox
		$gWMI_ArraySelectEntries[12][0] = $idAST_CIMv2
		$gWMI_ArraySelectEntries[13][0] = $idAST_Open
		$gWMI_ArraySelectEntries[14][0] = $g_idAST_Save
	EndIf
	If $statusDo Then ; disable those that are enabled
		For $n = 1 To $gWMI_ArraySelectEntries[0][0]
			$gWMI_ArraySelectEntries[$n][1] = BitAND(GUICtrlGetState($gWMI_ArraySelectEntries[$n][0]), $GUI_ENABLE)
			If $gWMI_ArraySelectEntries[$n][1] Then GUICtrlSetState($gWMI_ArraySelectEntries[$n][0], $GUI_DISABLE)
		Next
	Else ; enable those that were enable
		For $n = 1 To $gWMI_ArraySelectEntries[0][0]
			If $gWMI_ArraySelectEntries[$n][1] Then GUICtrlSetState($gWMI_ArraySelectEntries[$n][0], $GUI_ENABLE)
		Next
	EndIf
EndFunc   ;==>WMI_ArraySelectEntries_DisEnable

Func WMI_ArraySelectEntries_ReBuild(ByRef $b)
	Local $c, $d, $e, $n, $a = StringSplit(GUICtrlRead_Sci($g_idAST_ScriptCode), @CRLF, 1)
	ReDim $b[$b[0][0] + 1][10]
	$b[0][1] = 0
	$b[0][2] = 0
	For $n = 1 To $a[0]
		If StringInStr($a[$n], '$aReturn[0][0] = ') And $b[0][1] Then ExitLoop
		If StringInStr($a[$n], '][ 0 ] = "') And StringInStr($a[$n], '$aReturn[ ') Then
			$b[0][1] = $b[0][1] + 1
			$b[$b[0][1]][1] = _GUICtrlListView_GetItemChecked($hWMI_ArraySelectEntries, $b[0][1] - 1)
			If $b[$b[0][1]][1] = False Then
				$b[0][2] = $b[0][2] + 1
				$b[$b[0][1]][2] = $b[0][2]
			Else
				$b[$b[0][1]][2] = 0
			EndIf
		EndIf
	Next
	Local $sl = StringLen($b[0][2])
	For $n = 1 To $a[0]
		If StringStripWS($a[$n], 3) = "Next" Then ExitLoop
		If StringInStr($a[$n], '][ 0 ] = "') And StringInStr($a[$n], '$aReturn[ ') Then
			$b[0][3] = 1
			$c = StringSplit($a[$n], "[]", 0)
			$d = Int($c[2])
			If $b[$d][2] Then
				$a[$n] = $c[1] & '[ ' & niceSpacing($b[$d][2], $sl) & ' ][ 0 ]' & $c[5]
			Else
				$a[$n] = ";;;remove;;;"
			EndIf
		EndIf
		If StringInStr($a[$n], '][ $aReturn[0][1] ] =') Then
			$b[0][3] = 1
			$c = StringSplit($a[$n], "[]", 0)
			$d = Int($c[2])
			If $b[$d][2] Then
				$a[$n] = $c[1] & '[ ' & niceSpacing($b[$d][2], $sl) & ' ][ $aReturn[0][1] ]' & $c[9]
			Else
				$a[$n] = ";;;remove;;;"
			EndIf
		EndIf
		If StringInStr($a[$n], "$aReturn[0][0] = ") And (Not StringInStr($a[$n], "$aReturn[0][0] = 0")) Then
			$c = StringSplit($a[$n], "=", 0)
			$a[$n] = $c[1] & '= ' & $b[0][2]
		EndIf
	Next
	Local $sOut = ""
	For $n = 1 To $a[0]
		If $a[$n] = ";;;remove;;;" Then ContinueLoop
		$sOut &= $a[$n] & @CRLF
	Next
	GUICtrlSetData_Sci($g_idAST_ScriptCode, $sOut)
EndFunc   ;==>WMI_ArraySelectEntries_ReBuild

Func WMI_ArraySelectEntries_Choose(ByRef $b)
	Local $n, $c, $a = StringSplit(GUICtrlRead_Sci($g_idAST_ScriptCode), @CRLF, 1)
	Dim $b[$a[0]][1]
	$b[0][0] = 0
	For $n = 1 To $a[0]
		If StringInStr($a[$n], '][ 0 ] = "') And StringInStr($a[$n], '$aReturn[ ') Then
			$b[0][0] = $b[0][0] + 1
			$c = StringSplit($a[$n], '"')
			$b[$b[0][0]][0] = $c[2]
		EndIf
	Next
	ReDim $b[$b[0][0] + 1][1]
	If $g_idAST_ScriptCode Then
		Local $aControlGetPos = ControlGetPos("", "", GUICtrlGetHandle($g_idAST_ScriptCode))
	Else
		Local $aControlGetPos = ControlGetPos("", "", GUICtrlGetHandle($aSciLexer[3]))
	EndIf
	$hWMI_ArraySelectEntries = GUICtrlCreateListView("", $aControlGetPos[0], $aControlGetPos[1], $aControlGetPos[2], $aControlGetPos[3])
	GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKBOTTOM)
	_fontCtrlSet($g_idAST_ScriptCodeFont, $hWMI_ArraySelectEntries)
	_GUICtrlListView_SetExtendedListViewStyle($hWMI_ArraySelectEntries, BitOR($LVS_EX_FULLROWSELECT, $LVS_EX_CHECKBOXES))
	_GUICtrlListView_AddColumn($hWMI_ArraySelectEntries, "Check those properties you want to remove", $aControlGetPos[2] - 40)
	For $n = 1 To $b[0][0]
		_GUICtrlListView_AddItem($hWMI_ArraySelectEntries, '[' & $n & ']  ' & $b[$n][0])
	Next
EndFunc   ;==>WMI_ArraySelectEntries_Choose

Func filterClassesCombo($FilterInputStr)
	Local $sOut, $n, $m, $i
	Local $sDefaultComboStr = FileRead($sCacheFileBaseName & StringReplace($g_sCurrentNamespace, '\', '_') & '.dat')
	If $sDefaultComboStr = "" Then
		GUICtrlSetData($g_idWMI_Classes, "", "")
		GUICtrlSetData($g_idWMI_Classes, "|No dynamic classes found in current namespace.|Select a different namespace", "No dynamic classes found in current namespace.")
		Return
	EndIf

	Local $aDefaultComboStr = StringSplit($sDefaultComboStr, '|')

	$sOut = $aDefaultComboStr[2]
	Local $aFilter = StringSplit(StringStripWS($FilterInputStr, 7), " ")
	If $aFilter[1] = "" Then
		$sOut = $sDefaultComboStr
	Else
		For $n = 3 To $aDefaultComboStr[0]
			$i = 1
			For $m = 1 To $aFilter[0]
				If Not StringInStr($aDefaultComboStr[$n], $aFilter[$m]) Then $i = 0
			Next
			If $i Then $sOut &= "|" & $aDefaultComboStr[$n]
		Next
	EndIf
	GUICtrlSetData($g_idWMI_Classes, "", "")
	GUICtrlSetData($g_idWMI_Classes, $sOut, $aDefaultComboStr[2])
EndFunc   ;==>filterClassesCombo

Func Func_g_idAST_Run()
;~ 	GUICtrlSetState($g_idAST_Run, $GUI_DISABLE) ; err1 = it messes with ScITE thing =/
	GUICtrlSetState($idAST_WMI_ArraySelectEntries, $GUI_DISABLE)
	GUICtrlSetState($idAST_CIMv2, $GUI_DISABLE)
	GUICtrlSetState($idAST_WMISource, $GUI_DISABLE)
	GUICtrlSetState($idAST_Open, $GUI_DISABLE)
	GUICtrlSetState($g_idAST_Save, $GUI_DISABLE)
	GUICtrlSetState($idAST_Quit, $GUI_DISABLE)
	If GUICtrlRead($g_idAST_Run) = "STOP" Then
		If $iPid Then ProcessClose($iPid)
		$SEC = "not the same @SEC"
	Else
		$iPid = RunScript()
		$LookForAutoItErrorWindow = 1
		$LookForAutoItDialog = ""
		$LookForAutoItTimer = 1
	EndIf
	If $iPid Then
		If $iPid <> @AutoItExe Then GUICtrlSetData($g_idAST_Run, "STOP")
	EndIf
;~ 	GUICtrlSetState($g_idAST_Run, $GUI_ENABLE) ; err1
	GUICtrlSetState($idAST_WMI_ArraySelectEntries, $GUI_ENABLE)
EndFunc   ;==>Func_g_idAST_Run

Func RotateArray_nextCount()
	$iRotateArray += 1
	If $iRotateArray > 3 Then $iRotateArray = 0
EndFunc   ;==>RotateArray_nextCount

Func GUICtrlReadStripExtra($i)
	Local $s = GUICtrlRead($i)
	If StringInStr($s, " ") Then
		$s = StringLeft($s, StringInStr($s, " ") - 1)
		Return $s
	Else
		Return $s
	EndIf
EndFunc   ;==>GUICtrlReadStripExtra

; ********************************************************************
; * LoadWMINamespaces
; ********************************************************************
Func LoadWMINamespaces()
	GUICtrlSetState($g_idWMI_Namespace, $GUI_DISABLE)
	GUICtrlSetState($g_idWMI_Classes, $GUI_DISABLE)
	Local $sCsvListOfNamespaces = ""
	$sNamespacesCombo = ""

	Local $n, $sWaitNamespaces = "Please wait, Loading WMI Namespaces"
	GUICtrlSetData($g_idWMI_Namespace, $sWaitNamespaces, $sWaitNamespaces)
	_GUICtrlComboBox_SetDroppedWidth($g_idWMI_Namespace, 500)

	Local $sDat = FileRead($sCacheFileBaseName & "Namespaces.dat")
	If Not StringInStr($sDat, "root\CIMV2") Then

		EnumNamespaces("root", $sCsvListOfNamespaces)

		Local $aNamespaces = StringSplit($sCsvListOfNamespaces, ",")

		For $n = 1 To UBound($aNamespaces) - 1
			$sNamespacesCombo = $sNamespacesCombo & "|" & $aNamespaces[$n]
		Next

		If StringInStr($sNamespacesCombo, "root") And Not StringInStr($sNamespacesCombo, "root\CIMV2") Then
			$iNamespacesComboLimited = 1
			$sNamespacesCombo &= "|root\CIMV2"
			If Not StringInStr($sNamespacesCombo, "root\WMI") Then $sNamespacesCombo &= "|root\WMI"
			If Not StringInStr($sNamespacesCombo, "root\DEFAULT") Then $sNamespacesCombo &= "|root\DEFAULT"
		EndIf
		FileWrite($sCacheFileBaseName & "Namespaces.dat", $sNamespacesCombo)
	Else
		$sNamespacesCombo = $sDat
	EndIf
	GUICtrlSetData($g_idWMI_Namespace, $sNamespacesCombo, "root\CIMV2")
	_GUICtrlComboBox_SetDroppedWidth($g_idWMI_Namespace, 500)
	GUICtrlSetState($g_idWMI_Namespace, $GUI_ENABLE)
	GUICtrlSetState($g_idWMI_Classes, $GUI_ENABLE)
EndFunc   ;==>LoadWMINamespaces

; ********************************************************************
; * EnumNamespaces
; ********************************************************************
Func EnumNamespaces($sNamespace, ByRef $sTmpCsvListOfNamespaces)
	If $sTmpCsvListOfNamespaces = "" Then
		$sTmpCsvListOfNamespaces = $sNamespace
	Else
		$sTmpCsvListOfNamespaces = $sTmpCsvListOfNamespaces & "," & $sNamespace
	EndIf

	; Local $sComputer = $g_sWMISource
	Local $oWMIService = ObjGet("winmgmts:\\" & $g_sWMISource & "\" & $sNamespace)

	If Not @error Then

		Local $oColNameSpaces = $oWMIService.InstancesOf("__NAMESPACE")

		For $oNameSpace In $oColNameSpaces
			EnumNamespaces($sNamespace & "\" & $oNameSpace.Name, $sTmpCsvListOfNamespaces)
		Next
	Else
		$sTmpCsvListOfNamespaces = ""
	EndIf
EndFunc   ;==>EnumNamespaces

; ********************************************************************
; * HandleNamespaceChange
; ********************************************************************
Func HandleNamespaceChange()
	GUICtrlSetState($g_idWMI_Namespace, $GUI_DISABLE)
	GUICtrlSetState($g_idWMI_Classes, $GUI_DISABLE)
	;'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	; Clear the WMI classes pulldown location.
	;'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	Local $sSelectedNamespace = GUICtrlRead($g_idWMI_Namespace)

	; Disable the namespace combobox until class load has been completed
	GUICtrlSetState($g_idWMI_Namespace, $GUI_DISABLE)

	Local $sWMIWaitMsg = "Please wait, trying to load WMI Classes in namespace " & $sSelectedNamespace
	GUICtrlSetData($g_idWMI_Classes, $sWMIWaitMsg, $sWMIWaitMsg)
	GUICtrlSetData_Sci($g_idAST_ScriptCode, "One moment..." & IsAdmin_ForHelpStr() & @CRLF & $sHelpString)

	LoadWMIClasses()
	$g_sCurrentNamespace = "\" & $sSelectedNamespace

	;'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	; Clear the code textarea and disable run and save.
	;'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	GUICtrlSetData_Sci($g_idAST_ScriptCode, $sHelpString & @CRLF & @CRLF & 'Ready.', "")

	GUICtrlSetState($g_idWMI_Namespace, $GUI_ENABLE)
	GUICtrlSetState($g_idAST_Run, $GUI_DISABLE)
	GUICtrlSetState($idAST_WMI_ArraySelectEntries, $GUI_DISABLE)
	GUICtrlSetState($g_idAST_Save, $GUI_DISABLE)
EndFunc   ;==>HandleNamespaceChange

; ********************************************************************
; * LoadWMIClasses
; *
; * Fetch all the classes in the currently selected namespace, and
; * populate the keys of a dictionary object with the names of all
; * dynamic (non-association) classes. Then we transfer the keys to
; * an array, sort the array, and finally use the sorted array to
; * populate the WMI classes pulldown.
; ********************************************************************
Func LoadWMIClasses()

	If FileExists($sCacheFileBaseName & StringReplace($g_sCurrentNamespace, '\', '_') & '.dat') Then
		Local $sCache = FileRead($sCacheFileBaseName & StringReplace($g_sCurrentNamespace, '\', '_') & '.dat')
		If $ShowOnlyDynamicClasses = 1 And StringInStr($sCache, "(") Then
			; carry on and refresh cache
		ElseIf $ShowOnlyDynamicClasses = 0 And Not StringInStr($sCache, "(") Then
			; carry on and refresh cache
		Else
			GUICtrlSetData($g_idWMI_Classes, $sCache, "Select a WMI class")
			$iClassesComboError = 0
			_GUICtrlComboBox_SetDroppedWidth($g_idWMI_Classes, 500)
			If GUICtrlRead($g_idAST_FilterInput) <> "" Then filterClassesCombo(GUICtrlRead($g_idAST_FilterInput))
			Return
		EndIf
	EndIf

	Local $_ClassQualifiers = ""
	Const $SORT_KEYS = 1
	; Const $SORT_ITEMS = 2

	Local $oClassDictionary = ObjCreate("Scripting.Dictionary")
	Local $oQualifierDictionary = ObjCreate("Scripting.Dictionary")

	Local $sComputer = "."
	Local $oWMIService = ObjGet("winmgmts:\\" & $sComputer & $g_sCurrentNamespace)

	If Not @error Then

		For $oClass In $oWMIService.SubclassesOf()

			;ConsoleWrite('+ >' & $oClass.Path_.Class & '<' & @CRLF)
			;https://msdn.microsoft.com/en-us/library/ms974592.aspx

			For $objQualifier In $oClass.Qualifiers_() ; Dummy (), because it ends with an underscore !
				$oQualifierDictionary.Add(StringLower($objQualifier.Name), "")
			Next

			If $ShowOnlyDynamicClasses Then
				If $oQualifierDictionary.Exists("dynamic") Then
					;$TempVar = $oClass.Path_.Class
					;$oClassDictionary.Add($TempVar, "")	; Can't use object in arguments ?!!
					$oClassDictionary.Add($oClass.Path_.Class, "")
				EndIf
			Else
				$_ClassQualifiers = ""
				If $oQualifierDictionary.Exists("abstract") Then $_ClassQualifiers &= "(Abstract)"
				If $oQualifierDictionary.Exists("dynamic") Then $_ClassQualifiers &= "(Dynamic)"
				If $oQualifierDictionary.Exists("association") Then $_ClassQualifiers &= "(Association)"
				If Not ($_ClassQualifiers = "") Then $oClassDictionary.Add($oClass.Path_.Class & " " & $_ClassQualifiers, "")
			EndIf
			$oQualifierDictionary.RemoveAll

		Next

		$oQualifierDictionary = ""

		;'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		; If the current namespace contains dynamic classes...
		;'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		If $oClassDictionary.Count Then

			;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
			; Sort the dictionary.
			;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
			SortDictionary($oClassDictionary, $SORT_KEYS)

			;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
			; Populate the WMI classes pulldown with the sorted dictionary.
			;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

			Local $sClassesCombo = "|Select a WMI class"
			$iClassesComboError = 0

			For $strWMIClass In $oClassDictionary ;  method .Keys is not an object ??
				$sClassesCombo &= "|" & $strWMIClass
			Next

			GUICtrlSetData($g_idWMI_Classes, $sClassesCombo, "Select a WMI class")
			FileWrite($sCacheFileBaseName & StringReplace($g_sCurrentNamespace, '\', '_') & '.dat', $sClassesCombo)

		EndIf
	EndIf

	If @error Or $oClassDictionary.Count = 0 Then
		;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		; And If the current namespace doesn't contain dynamic classes.
		;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		$iClassesComboError = 1
		GUICtrlSetState($g_idAST_Run, $GUI_DISABLE)
		GUICtrlSetState($idAST_WMI_ArraySelectEntries, $GUI_DISABLE)
		GUICtrlSetData($g_idWMI_Classes, "|No dynamic classes found in current namespace.|Select a different namespace", "No dynamic classes found in current namespace.")

	EndIf
	_GUICtrlComboBox_SetDroppedWidth($g_idWMI_Classes, 500)
	$oClassDictionary = ""
	If GUICtrlRead($g_idAST_FilterInput) <> "" Then filterClassesCombo(GUICtrlRead($g_idAST_FilterInput))
EndFunc   ;==>LoadWMIClasses

; ********************************************************************
; * SortDictionary
; *
; * Shell sort based on:
; * http://support.microsoft.com/support/kb/articles/q246/0/67.asp
; ********************************************************************
Func SortDictionary(ByRef $oDict, $iSort)
	Const $iDictKey = 1
	Const $iDictItem = 2

	Local $asDict[1][3]

	Local $iCount = $oDict.Count

	If $iCount > 1 Then

		ReDim $asDict[$iCount][3]

		Local $i = 0
		For $oKey In $oDict

			$asDict[$i][$iDictKey] = String($oKey)
			$asDict[$i][$iDictItem] = String($oDict($oKey))

			$i = $i + 1
		Next

		;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		; Perform a shell sort of the 2D string array
		;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		For $i = 0 To ($iCount - 2)
			For $j = $i To ($iCount - 1)
				If $asDict[$i][$iSort] > $asDict[$j][$iSort] Then
					Local $sKey = $asDict[$i][$iDictKey]
					Local $sItem = $asDict[$i][$iDictItem]
					$asDict[$i][$iDictKey] = $asDict[$j][$iDictKey]
					$asDict[$i][$iDictItem] = $asDict[$j][$iDictItem]
					$asDict[$j][$iDictKey] = $sKey
					$asDict[$j][$iDictItem] = $sItem
				EndIf
			Next
		Next

		;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		; Erase the contents of the dictionary object
		;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		$oDict.RemoveAll

		;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		; Repopulate the dictionary with the sorted information
		;''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		For $i = 0 To ($iCount - 1)
			$oDict.Add($asDict[$i][$iDictKey], $asDict[$i][$iDictItem])
		Next

	EndIf
EndFunc   ;==>SortDictionary

; ********************************************************************
; * ComposeCode
; ********************************************************************
Func ComposeCode()
	If GUICtrlRead($g_idWMI_Namespace) = "" Then Return
	If $iClassesComboError Then Return
	Local $oClass = ""

	Local $TAB = $sTab
	Local $iSpaceArrayDigit = 0

	Local $aOutput[1000][100]
	$aOutput[0][0] = 0 ; UBound( x , 1 )
	$aOutput[0][1] = 0 ; UBound( x , 2 )
	Local $iOutput = 0

	Local $sSelectedClass = GUICtrlRead($g_idWMI_Classes)
	; Check If a valid class has been selected

	If $sSelectedClass = "Select a WMI class" Or _
			$sSelectedClass = "No dynamic classes found in current namespace." Or _
			$sSelectedClass = "Select a different namespace" Then

		; Disable Web, Run and Save buttons, because no valid code has been generated

		GUICtrlSetData_Sci($g_idAST_ScriptCode, $sHelpString & @CRLF & @CRLF & 'Ready.', "")
		GUICtrlSetState($g_idAST_Web, $GUI_DISABLE)
		GUICtrlSetState($g_idAST_Run, $GUI_DISABLE)
		GUICtrlSetState($idAST_WMI_ArraySelectEntries, $GUI_DISABLE)
		GUICtrlSetState($g_idAST_Save, $GUI_DISABLE)
		GUICtrlSetState($g_idAST_ScITE_insert, $GUI_DISABLE)
		WinSetTitle($g_Form, "", $sTitle)
		redrawHelpStr()
		Return
	EndIf

	$sSelectedClass = GUICtrlReadStripExtra($g_idWMI_Classes)

	Local $bHasDates = False ; Flag: output has date fields
	Local $sHeaderStart = Chr(34)
	Local $sRowStart = Chr(34)
	Local $sColumnSeparator = ": "
	Local $sRowEnd = " & @CRLF"
	Local $sScriptCode = ""
	Local $sClassMethods = @CRLF & $TAB & "; Class Methods:" & @CRLF & $TAB & ";" & @CRLF
	Local $_ListAllPropertiesAndMethods = ""

	Local $sComputerCommand = $TAB & 'Local $sComputer = "' & $gd_ComputerName & '"' & @CRLF
	$sComputerCommand &= $TAB & 'Local $sUser = "' & $gd_UserName & '"' & @CRLF
	$sComputerCommand &= $TAB & 'Local $sPassword = "' & $gd_UserPassword & '"'

	WinSetTitle($g_Form, "", $sTitle & " " & $g_sCurrentNamespace & ":" & $sSelectedClass)

	Local $oWMIService = ObjGet("winmgmts:{impersonationLevel=impersonate}!\\" & "." & $g_sCurrentNamespace) ; for now all code building is from the current PC, I'd have to rewrite more to pull from the remote PC
	If Not IsObj($oWMIService) Then Return
;~ 	If $isAdminStr = "[Admin]" Then
	$oClass = $oWMIService.Get($sSelectedClass, 0x20000); wbemFlagUseAmendedQualifiers
;~ 	Else
;~ 		$oClass = $oWMIService.Get($sSelectedClass)
;~ 	EndIf

	Local $_WMI_Class_AllPropertiesAndMethods = ""
	Local $sHeadder = "List of all the Properties and Methods for " & $g_sCurrentNamespace & ":" & $sSelectedClass
	If IsObj($oClass) Then
		$_WMI_Class_AllPropertiesAndMethods = _WMI_Class_AllPropertiesAndMethods($oClass, $sSelectedClass, $aOutput, $sHeadder)
		For $oProperty In $oClass.Methods_()
			$sClassMethods &= $TAB & "; " & $oProperty.Name & @CRLF
		Next
		If StringRight($sClassMethods, 3) = ";" & @CRLF Then $sClassMethods &= $TAB & "; ( this Class did not list methods )" & @CRLF
		$sScriptCode &= ""
		$sScriptCode &= $TAB & "; Generated by AutoIt ScriptOMatic" & @CRLF & @CRLF
		$sScriptCode &= $TAB & "; Description: " & StringReplace(StringReplace($aOutput[0][2], @LF, " "), '. ', '.' & @CRLF & $TAB & '; ' & $TAB & $TAB) & @CRLF & @CRLF
		If $g_sOutputFormat = "Array" Then $sScriptCode &= $sClassMethods & @CRLF & @CRLF
		$sScriptCode &= $TAB & "Local $wbemFlagReturnImmediately = 0x10" & @CRLF
		$sScriptCode &= $TAB & "Local $wbemFlagForwardOnly = 0x20" & @CRLF
		$sScriptCode &= $TAB & 'Local $colItems = ""' & @CRLF
		If $g_sOutputFormat <> "Array" Then $sScriptCode &= $sComputerCommand & @CRLF
		$sScriptCode &= $TAB & 'Local $sReturn=""' & @CRLF
		If $g_sOutputFormat = "Array" Then
			$sScriptCode &= $TAB & "Local $iExt = 0" & @CRLF
			$sScriptCode &= $TAB & "If 1 > Int( $iLimit ) Then $iLimit = 1" & @CRLF
			$sScriptCode &= $TAB & 'Local $aReturn[1000][ Int( $iLimit ) + 1]' & @CRLF
			$sScriptCode &= $TAB & '$aReturn[0][0] = 0' & @CRLF
			$sScriptCode &= $TAB & '$aReturn[0][1] = 0' & @CRLF
			$sScriptCode &= $TAB & 'Local $aErr[1][2] = [[0, 0]]' & @CRLF
		EndIf

		If $g_sOutputFormat = "HTML" Then
			$sScriptCode &= $TAB & "$sReturn &= '<html><head><title>ScriptOMatic HTML Output</title></head><body> " & _
					"<style>table {font-size: 10pt; font-family: arial;} th {background-color: buttonface; font-decoration: bold;} </style>'" & @CRLF
;~ 						"<table BORDER=" & Chr(34) & "1" & Chr(34) & "><tr><th>Property</th><th>Value</th></tr>'" & @CRLF
			$sRowStart = Chr(34) & "<tr><td>"
			$sHeaderStart = "'<tr bgcolor=" & Chr(34) & "yellow" & Chr(34) & "><td>' & " & Chr(34)
			$sColumnSeparator = "</td><td>&nbsp;"
			$sRowEnd = " & " & Chr(34) & "</td></tr>" & Chr(34) & " & @CRLF"
		EndIf

		If $g_sOutputFormat = "HTML" Then
			$sScriptCode &= $TAB & "$sReturn &= @CRLF & '<h3>" & $sSelectedClass & "</h3>' & @CRLF" & @CRLF
			$sScriptCode &= $TAB & 'FileDelete(@TempDir & "\ScriptOMatic.' & $sSelectedClass & '.htm")' & @CRLF
		EndIf

		If $g_sOutputFormat = "Text" Then $sScriptCode &= $TAB & 'FileDelete(@TempDir & "\ScriptOMatic.' & $sSelectedClass & '.txt")' & @CRLF
		$sScriptCode &= @CRLF
		$sScriptCode &= $TAB & 'If $sComputer & $sUser & $sPassword = "." Then' & @CRLF
		$sScriptCode &= $TAB & $TAB & 'ToolTip("...ObjGet", @DesktopWidth - 30,@DesktopHeight - 130, "ScriptOMatic - ' & $sSelectedClass & '",1,4)' & @CRLF
		$sScriptCode &= $TAB & $TAB & "Local $oWMIService = ObjGet(" & Chr(34) & "winmgmts:\\" & Chr(34) & " & $sComputer & " & Chr(34) & $g_sCurrentNamespace & Chr(34) & ")" & @CRLF
		$sScriptCode &= $TAB & $TAB & 'If Not IsObj($oWMIService) Then Return SetError(2, 99, $aErr)' & @CRLF
		$sScriptCode &= $TAB & 'Else' & @CRLF
		$sScriptCode &= $TAB & $TAB & 'ToolTip("...ObjCreate", @DesktopWidth - 30,@DesktopHeight - 130, "ScriptOMatic - ' & $sSelectedClass & '",1,4)' & @CRLF
		$sScriptCode &= $TAB & $TAB & 'Local $wmiLocator = ObjCreate("WbemScripting.SWbemLocator")' & @CRLF
		$sScriptCode &= $TAB & $TAB & 'If Not IsObj($wmiLocator) Then Return SetError(3, 99, $aErr)' & @CRLF
		$sScriptCode &= $TAB & $TAB & 'ToolTip("...ConnectServer", @DesktopWidth - 30,@DesktopHeight - 130, "ScriptOMatic - ' & $sSelectedClass & '",1,4)' & @CRLF
		$sScriptCode &= $TAB & $TAB & 'Local $oWMIService = $wmiLocator.ConnectServer($sComputer, ' & Chr(34) & $g_sCurrentNamespace & Chr(34) & ', $sUser, $sPassword)' & @CRLF
		$sScriptCode &= $TAB & $TAB & 'If Not IsObj($oWMIService) Then Return SetError(4, 99, $aErr)' & @CRLF
		$sScriptCode &= $TAB & 'EndIf' & @CRLF
		$sScriptCode &= @CRLF
		$sScriptCode &= $TAB & 'ToolTip("...ExecQuery", @DesktopWidth - 30,@DesktopHeight - 130, "ScriptOMatic - ' & $sSelectedClass & '",1,4)' & @CRLF
		$sScriptCode &= $TAB & "Local $colItems = $oWMIService.ExecQuery(" & Chr(34) & "SELECT * FROM " & $sSelectedClass & Chr(34) & ", _" & @CRLF
		$sScriptCode &= $TAB & '                     "WQL", $wbemFlagReturnImmediately + $wbemFlagForwardOnly)' & @CRLF & @CRLF
		$sScriptCode &= $TAB & 'ToolTip("...ExecQuery executed."& @CR &"...waiting for data.", @DesktopWidth - 30,@DesktopHeight - 130, "ScriptOMatic - ' & $sSelectedClass & '",1,4)' & @CRLF
		$sScriptCode &= $TAB & "If IsObj($colItems) Then" & @CRLF & @CRLF

		If $g_sOutputFormat <> "Array" Then
			$sScriptCode = StringReplace($sScriptCode, 'Return SetError(2, 99, $aErr)', 'Exit MsgBox(262144, "WMI ScriptOMatic error", "ObjGet failed")')
			$sScriptCode = StringReplace($sScriptCode, 'Return SetError(3, 99, $aErr)', 'Exit MsgBox(262144, "WMI ScriptOMatic error", "ObjCreate failed")')
			$sScriptCode = StringReplace($sScriptCode, 'Return SetError(4, 99, $aErr)', 'Exit MsgBox(262144, "WMI ScriptOMatic error", "ConnectServer failed")')
		EndIf

		If $g_sOutputFormat = "Array" Then $sScriptCode &= $TAB & $TAB & "; Class Properties: Names:" & @CRLF & $TAB & $TAB & ";" & @CRLF & @CRLF

		If $g_sOutputFormat = "Array" Then
			For $oProperty In $oClass.Properties_()
				$iSpaceArrayDigit += 1
			Next
			$iSpaceArrayDigit = StringLen($iSpaceArrayDigit)

			For $oProperty In $oClass.Properties_()
				$iOutput += 1
				$sScriptCode &= $TAB & $TAB & '$aReturn[ ' & niceSpacing($iOutput, $iSpaceArrayDigit) & ' ][ 0 ] = "' & $oProperty.Name & '"' & @CRLF
			Next
			$sScriptCode &= $TAB & $TAB & '$aReturn[0][0] = ' & $iOutput & @CRLF
		EndIf

		If $g_sOutputFormat <> "Array" Then $sScriptCode &= $TAB & $TAB & "Local $iCounter = 0" & @CRLF
		$sScriptCode &= $TAB & $TAB & "For $objItem In $colItems" & @CRLF
		If $g_sOutputFormat <> "Array" Then $sScriptCode &= $TAB & $TAB & $TAB & "$iCounter += 1" & @CRLF

		If $g_sOutputFormat = "HTML" Or $g_sOutputFormat = "Text" Then
			$sScriptCode &= $TAB & $TAB & $TAB & 'If Not Mod( $iCounter , 100 ) Then' & @CRLF
			$sScriptCode &= $TAB & $TAB & $TAB & $TAB & 'ToolTip("...adding "& $iCounter &" of ??", @DesktopWidth - 30,@DesktopHeight - 130, "ScriptOMatic - ' & $sSelectedClass & '",1,4)' & @CRLF
			If $g_sOutputFormat = "Text" Then $sScriptCode &= $TAB & $TAB & $TAB & $TAB & 'FileWriteLine(@TempDir & "\ScriptOMatic.' & $sSelectedClass & '.txt", $sReturn )' & @CRLF
			If $g_sOutputFormat = "HTML" Then $sScriptCode &= $TAB & $TAB & $TAB & $TAB & 'FileWriteLine(@TempDir & "\ScriptOMatic.' & $sSelectedClass & '.htm", $sReturn )' & @CRLF
			$sScriptCode &= $TAB & $TAB & $TAB & $TAB & '$sReturn = ""' & @CRLF
			$sScriptCode &= $TAB & $TAB & $TAB & 'EndIf' & @CRLF
		EndIf

		If $g_sOutputFormat = "Dialog" Then $sScriptCode &= $TAB & $TAB & $TAB & 'ToolTip("Showing "& $iCounter &" of ??", @DesktopWidth - 30,@DesktopHeight - 130, "ScriptOMatic - ' & $sSelectedClass & '",1,4)' & @CRLF
		If $g_sOutputFormat = "Dialog" Then
			$sScriptCode &= $TAB & $TAB & $TAB & "$sReturn &= " & $sHeaderStart & "Computer" & $sColumnSeparator & Chr(34) & " & $sComputer " & $sRowEnd & @CRLF
			$sScriptCode &= $TAB & $TAB & $TAB & "$sReturn &= " & Chr(34) & "==========================================" & Chr(34) & $sRowEnd & @CRLF
		EndIf
		If $g_sOutputFormat = "HTML" Then $sScriptCode &= $TAB & $TAB & $TAB & '$sReturn &= ''<table BORDER="1"><tr><th>Property</th><th>Value</th></tr>''&@CRLF' & @CRLF
		If $g_sOutputFormat = "Array" Then
			$sScriptCode &= $TAB & $TAB & $TAB & "$aReturn[0][1] = $aReturn[0][1] + 1" & @CRLF
			$sScriptCode &= $TAB & $TAB & $TAB & 'If Not Mod( $aReturn[0][1] , 100 ) Then ToolTip("...adding "& $aReturn[0][1] &" of "&$iLimit &" ??", @DesktopWidth - 30,@DesktopHeight - 130, "ScriptOMatic - ' & $sSelectedClass & '",1,4)' & @CRLF
			$sScriptCode &= $TAB & $TAB & $TAB & "If $aReturn[0][1] > $iLimit Then" & @CRLF
			$sScriptCode &= $TAB & $TAB & $TAB & $TAB & "$iExt = 2" & @CRLF
			$sScriptCode &= $TAB & $TAB & $TAB & $TAB & "ExitLoop" & @CRLF
			$sScriptCode &= $TAB & $TAB & $TAB & "EndIf" & @CRLF & @CRLF
			$sScriptCode &= $TAB & $TAB & $TAB & "; Class Properties: Values:" & @CRLF
			$sScriptCode &= $TAB & $TAB & $TAB & ";" & @CRLF & @CRLF
			$iOutput = 0
		EndIf

		For $oProperty In $oClass.Properties_() ; Must use (), because method ends with an underscore
			$iOutput += 1
			If $g_sOutputFormat = "Array" Then
				If $oProperty.IsArray = True Then
					$sScriptCode &= $TAB & $TAB & $TAB & "$aReturn[ " & niceSpacing($iOutput, $iSpaceArrayDigit) & " ][ $aReturn[0][1] ] = Array_Join( $objItem." & $oProperty.Name & " )" & @CRLF
				ElseIf $oProperty.CIMTYPE = 101 Then
					$bHasDates = True
					$sScriptCode &= $TAB & $TAB & $TAB & "$aReturn[ " & niceSpacing($iOutput, $iSpaceArrayDigit) & " ][ $aReturn[0][1] ] = WMIDateStringToDate( $objItem." & $oProperty.Name & " )" & @CRLF
				Else
					$sScriptCode &= $TAB & $TAB & $TAB & "$aReturn[ " & niceSpacing($iOutput, $iSpaceArrayDigit) & " ][ $aReturn[0][1] ] = " & itsOwnFuncReturn("$objItem.", $oProperty.Name, $aOutput) & @CRLF
				EndIf
			Else
				If $oProperty.IsArray = True Then
					$sScriptCode &= $TAB & $TAB & $TAB & "$str" & $oProperty.Name & " = Array_Join($objItem." & $oProperty.Name & ")" & @CRLF
					$sScriptCode &= $TAB & $TAB & $TAB & "$sReturn &= " & $sRowStart & $oProperty.Name & $sColumnSeparator & Chr(34) & " & $str" & $oProperty.Name & $sRowEnd & @CRLF
				ElseIf $oProperty.CIMTYPE = 101 Then
					$bHasDates = True
					$sScriptCode &= $TAB & $TAB & $TAB & "$sReturn &= " & $sRowStart & $oProperty.Name & $sColumnSeparator & Chr(34) & " & WMIDateStringToDate($objItem." & $oProperty.Name & ")" & $sRowEnd & @CRLF
				Else
					$sScriptCode &= $TAB & $TAB & $TAB & "$sReturn &= " & $sRowStart & $oProperty.Name & $sColumnSeparator & Chr(34) & " & " & itsOwnFuncReturn("$objItem.", $oProperty.Name, $aOutput) & $sRowEnd & @CRLF
				EndIf
			EndIf
		Next

		If $g_sOutputFormat = "Dialog" Then
			$sScriptCode &= $TAB & $TAB & $TAB & 'If MsgBox(1 + 262144 + 32,"WMI ScriptOMatic",$sReturn) = 2 Then ExitLoop ; the $MB_ICONQUESTION (32), is so it makes no sound when popup.' & @CRLF ; $MB_ICONQUESTION (32) = Question-mark icon ; it makes no sound on WinXP ( where I testd this )
			$sScriptCode &= $TAB & $TAB & $TAB & '$sReturn=""' & @CRLF
		EndIf

		If $g_sOutputFormat = "HTML" Then $sScriptCode &= $TAB & $TAB & $TAB & "$sReturn &= ""</table>""&@CRLF" & @CRLF
		If $g_sOutputFormat = "Text" Then $sScriptCode &= $TAB & $TAB & $TAB & "$sReturn &= @CRLF" & @CRLF
		$sScriptCode &= $TAB & $TAB & "Next" & @CRLF

		If $g_sOutputFormat = "Text" Then
			$sScriptCode &= $TAB & $TAB & ';ConsoleWrite($sReturn)' & @CRLF
			$sScriptCode &= $TAB & $TAB & 'FileWriteLine(@TempDir & "\ScriptOMatic.' & $sSelectedClass & '.txt", $sReturn )' & @CRLF
			$sScriptCode &= $TAB & $TAB & 'Run(@ComSpec & " /c start " & @TempDir & "\ScriptOMatic.' & $sSelectedClass & '.txt" , @TempDir, @SW_HIDE)' & @CRLF
		ElseIf $g_sOutputFormat = "HTML" Then
			$sScriptCode &= $TAB & $TAB & '$sReturn &= "</body></html>"' & @CRLF
			$sScriptCode &= $TAB & $TAB & 'FileWriteLine(@TempDir & "\ScriptOMatic.' & $sSelectedClass & '.htm", $sReturn )' & @CRLF
			$sScriptCode &= $TAB & $TAB & 'Run(@ComSpec & " /c start " & @TempDir & "\ScriptOMatic.' & $sSelectedClass & '.htm" , @TempDir, @SW_HIDE)' & @CRLF
		ElseIf $g_sOutputFormat = "Array" Then
			$sScriptCode &= $TAB & $TAB & 'If $aReturn[0][1] = 0  Then $iExt = 1' & @CRLF
			$sScriptCode &= $TAB & $TAB & 'ReDim $aReturn[$aReturn[0][0] + 1][$aReturn[0][1] + 1]' & @CRLF
			$sScriptCode &= $TAB & $TAB & 'Return SetError( 0 , $iExt , $aReturn )' & @CRLF
		EndIf

		$sScriptCode &= $TAB & "Else" & @CRLF

		If $g_sOutputFormat = "Array" Then
			$sScriptCode &= $TAB & $TAB & 'Return SetError(1 ,99 ,$aErr)' & @CRLF
		Else
			$sScriptCode &= $TAB & $TAB & 'MsgBox(262144 ,"WMI ScriptOMatic error","No WMI Objects Found for class: " & ' & Chr(34) & $sSelectedClass & Chr(34) & ' )' & @CRLF
		EndIf

		$sScriptCode &= $TAB & "EndIf" & @CRLF
		If $g_sOutputFormat <> "Array" Then $sScriptCode &= $TAB & "If $_nice_COMerrorArray[0][0] Then _nice_COMerrorHandler(2)" & @CRLF

		If $g_sOutputFormat = "Array" Then
			Local $sArrayDispLine = '_ArrayDisplay( $a ,"ScriptOMatic - ""' & $sSelectedClass & '""")' & @CRLF
			If $gd_ComputerName <> "." Then $sArrayDispLine = StringReplace($sArrayDispLine, '""")', '"" on ""' & $gd_ComputerName & '""")')
			Local $sArray_au3 = '#include <Array.au3>' & @CRLF & @CRLF
			If @Compiled Then $sArray_au3 = '#include "Array.au3"' & @CRLF & @CRLF
			If $iRotateArray > 1 Then
				$sArray_au3 = ""
				If FileExists(@ScriptDir & "\_Array2D_toHtml.au3") Then $sArray_au3 = '#include "' & @ScriptDir & "\_Array2D_toHtml.au3" & '"' & @CRLF & @CRLF
			EndIf

			$sScriptCode = $sArray_au3 & _
					'Opt("MustDeclareVars",1)' & @CRLF & _
					'Opt("TrayIconDebug",1)' & @CRLF & _
					'Opt("TrayAutoPause",0)' & @CRLF & _
					'Global $_nice_COMerrorArray, $_nice_COMerrorObj' & @CRLF & _
					'_nice_COMerrorHandler(1) ; COM error handler.' & @CRLF & @CRLF & _
					'ToolTip("mouse over the trayicon for debug info.", @DesktopWidth - 30,@DesktopHeight - 130, "ScriptOMatic - ' & $sSelectedClass & '",1,4)' & @CRLF & @CRLF & _
					"Local $a = _WMI_" & $sSelectedClass & "()" & @CRLF & _
					"If @error Then" & @CRLF & _
					$TAB & "Switch @error" & @CRLF & _
					$TAB & $TAB & "Case 1" & @CRLF & _
					$TAB & $TAB & $TAB & 'MsgBox(262144, "WMI ScriptOMatic error", "No WMI Objects Found for class: ""' & $sSelectedClass & '""" )' & @CRLF & _
					$TAB & $TAB & "Case 2" & @CRLF & _
					$TAB & $TAB & $TAB & 'MsgBox(262144, "WMI ScriptOMatic error", "ObjGet failed")' & @CRLF & _
					$TAB & $TAB & "Case 3" & @CRLF & _
					$TAB & $TAB & $TAB & 'MsgBox(262144, "WMI ScriptOMatic error", "ObjCreate failed")' & @CRLF & _
					$TAB & $TAB & "Case 4" & @CRLF & _
					$TAB & $TAB & $TAB & 'MsgBox(262144, "WMI ScriptOMatic error", "ConnectServer failed")' & @CRLF & _
					$TAB & $TAB & "Case Else" & @CRLF & _
					$TAB & $TAB & $TAB & 'MsgBox(262144, "WMI ScriptOMatic error", "unknown error")' & @CRLF & _
					$TAB & "EndSwitch" & @CRLF & _
					"Else" & @CRLF & _
					$TAB & "Switch @extended" & @CRLF & _
					$TAB & $TAB & "Case 0" & @CRLF & _
					$TAB & $TAB & $TAB & 'ToolTip("Done.", @DesktopWidth - 30,@DesktopHeight - 130, "ScriptOMatic - ' & $sSelectedClass & '",1,4)' & @CRLF & _
					$TAB & $TAB & "Case 1" & @CRLF & _
					$TAB & $TAB & $TAB & 'ToolTip("Nothing, you''ve got nothing."&@CR&@CR&"Adjust the query", @DesktopWidth - 30,@DesktopHeight - 130, "ScriptOMatic - ' & $sSelectedClass & '",2,4)' & @CRLF & _
					$TAB & $TAB & "Case 2" & @CRLF & _
					$TAB & $TAB & $TAB & 'ToolTip("More than you can chew."&@CR&@CR&"Adjust the ""$iLimit"" or the query", @DesktopWidth - 30,@DesktopHeight - 130, "ScriptOMatic - ' & $sSelectedClass & '",2,4)' & @CRLF & _
					$TAB & "EndSwitch" & @CRLF & _
					$TAB & 'If $_nice_COMerrorArray[0][0] Then _nice_COMerrorHandler(2)' & @CRLF & _
					$TAB & $sArrayDispLine & _
					"EndIf" & @CRLF & @CRLF & @CRLF & _
					"Func _WMI_" & $sSelectedClass & "( $iLimit = " & $iArrayDefaultLimit & ' , $sComputer = "' & $gd_ComputerName & '" , $sUser = "' & $gd_UserName & '" , $sPassword = "' & $gd_UserPassword & '" )' & @CRLF & @CRLF & _
					$sScriptCode & _
					"EndFunc" & @CRLF & @CRLF
		Else
			$sScriptCode &= @CRLF & @CRLF
			$sScriptCode = StringReplace($sScriptCode, @CRLF & $TAB, @CRLF)
		EndIf

		If $bHasDates Then
			$sScriptCode &= "Func WMIDateStringToDate($dtmDate)" & @CRLF
			$sScriptCode &= $TAB & "Return (StringMid($dtmDate, 5, 2) & ""/"" & _" & @CRLF
			$sScriptCode &= $TAB & $TAB & "StringMid($dtmDate, 7, 2) & ""/"" & StringLeft($dtmDate, 4) _" & @CRLF
			$sScriptCode &= $TAB & $TAB & "& "" "" & StringMid($dtmDate, 9, 2) & "":"" & StringMid($dtmDate, 11, 2) & "":"" & StringMid($dtmDate,13, 2))" & @CRLF
			$sScriptCode &= "EndFunc" & @CRLF
		EndIf

		If $g_sOutputFormat = "Array" Then
			Switch $iRotateArray
				Case 1
					$sScriptCode = StringReplace($sScriptCode, $TAB & $sArrayDispLine, $TAB & '_Array_Rotate2D( $a )' & @CRLF & $TAB & $sArrayDispLine)
					$sScriptCode &= @CRLF & Func_Array_Rotate2D($TAB)
				Case 2
					Local $sOut = ""
					$sOut &= $TAB & "FileDelete(@TempDir & '\ScriptOMatic.temp.htm')" & @CRLF
					$sOut &= $TAB & 'Local $sOut = _Array2D_toHtml($a, 0, "' & $sSelectedClass & '")' & @CRLF
					$sOut &= $TAB & "FileWrite(@TempDir & '\ScriptOMatic.temp.htm', $sOut)" & @CRLF
					$sOut &= $TAB & 'Run(@ComSpec & " /c start ' & @TempDir & '\ScriptOMatic.temp.htm", @TempDir, @SW_HIDE)' & @CRLF
					$sOut &= $TAB & 'Sleep(5000)' & @CRLF
					$sScriptCode = StringReplace($sScriptCode, $TAB & $sArrayDispLine, $sOut)
					If Not StringInStr($sScriptCode, "_Array2D_toHtml.au3") Then $sScriptCode &= @CRLF & Func_Array2D_toHtml($TAB)
				Case 3
					Local $sOut = $TAB & '_Array_Rotate2D($a)' & @CRLF
					$sOut &= $TAB & "FileDelete(@TempDir & '\ScriptOMatic.temp.htm')" & @CRLF
					$sOut &= $TAB & 'Local $sOut = _Array2D_toHtml($a, 1, "' & $sSelectedClass & '")' & @CRLF
					$sOut &= $TAB & "FileWrite(@TempDir & '\ScriptOMatic.temp.htm', $sOut)" & @CRLF
					$sOut &= $TAB & 'Run(@ComSpec & " /c start ' & @TempDir & '\ScriptOMatic.temp.htm", @TempDir, @SW_HIDE)' & @CRLF
;~ 						$sOut &= $TAB & "ShellExecute(@TempDir & '\ScriptOMatic.temp.htm')" & @CRLF ; it hangs at times, so I use "Run(.."
					$sOut &= $TAB & 'Sleep(5000)' & @CRLF
					$sScriptCode = StringReplace($sScriptCode, $TAB & $sArrayDispLine, $sOut)
					$sScriptCode &= @CRLF & Func_Array_Rotate2D($TAB)
					If Not StringInStr($sScriptCode, "_Array2D_toHtml.au3") Then $sScriptCode &= @CRLF & Func_Array2D_toHtml($TAB)
			EndSwitch
		EndIf
	Else
		$sScriptCode = "Error: No Class properties found for " & $g_sCurrentNamespace & "\" & $sSelectedClass
		;GUICtrlSetData($g_idWMI_Classes, "")
	EndIf

	If StringInStr($sScriptCode, "Array_Join(") Then $sScriptCode &= Func_Array_Join($TAB) & @CRLF

	$sScriptCode &= "#Region    # ValueToDescription Functions #" & @CRLF
	For $n = 1 To $aOutput[0][0] ; to add the ReturnInt_2_Str function, that even tho is not used here, the user may need/like them.
		If Int($aOutput[$n][0]) <> 3 Then ContinueLoop
		itsOwnFuncReturn("$objItem.", $aOutput[$n][1], $aOutput)
	Next

	Local $sWarning = ""
	If Int($aOutput[0][4]) > 60 Then $sWarning = "; Warning: some Func. names were too long for AU3Check. Those were renamed." & @CRLF & @CRLF
	$sScriptCode = $sWarning & $sScriptCode & @CRLF & @CRLF & StringReplace($aOutput[0][10], @TAB, $TAB) & _
			@CRLF & "#EndRegion # ValueToDescription Functions #" & @CRLF & _
			Func_nice_COMerrorHandler($TAB) & @CRLF & @CRLF & _
			"#comments-start" & @CRLF & @CRLF & $_WMI_Class_AllPropertiesAndMethods & "#comments-end" & @CRLF
	If Not StringInStr($sScriptCode, "Array.au3") Then
		If @Compiled Then
			If Not StringInStr($sScriptCode, "Global $_nice_COMerrorArray, $_nice_COMerrorObj") Then
				$sScriptCode = '#include "Array.au3"' & @CRLF & @CRLF & 'Global $_nice_COMerrorArray, $_nice_COMerrorObj' & @CRLF & '_nice_COMerrorHandler(1) ; COM error handler.' & @CRLF & @CRLF & $sScriptCode
			Else
				$sScriptCode = '#include "Array.au3"' & @CRLF & @CRLF & $sScriptCode
			EndIf
		Else
			If Not StringInStr($sScriptCode, "Global $_nice_COMerrorArray, $_nice_COMerrorObj") Then
				$sScriptCode = '#include <Array.au3>' & @CRLF & @CRLF & 'Global $_nice_COMerrorArray, $_nice_COMerrorObj' & @CRLF & '_nice_COMerrorHandler(1) ; COM error handler.' & @CRLF & @CRLF & $sScriptCode
			Else
				$sScriptCode = '#include <Array.au3>' & @CRLF & @CRLF & $sScriptCode
			EndIf
		EndIf
	EndIf

	GUICtrlSetData_Sci($g_idAST_ScriptCode, $sScriptCode)

;~ 	_ArrayDisplay( $aOutput )
	;'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	; Once the code is successfully composed and put into the
	; textarea, ensure that the run and save buttons are enabled.
	;'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

	GUICtrlSetState($g_idAST_Run, $GUI_ENABLE)
	GUICtrlSetState($idAST_WMI_ArraySelectEntries, $GUI_ENABLE)
	GUICtrlSetState($g_idAST_Save, $GUI_ENABLE)

	; Enable Web lookup button
	GUICtrlSetState($g_idAST_Web, $GUI_ENABLE)
	GUICtrlSetState($g_idAST_ScITE_insert, $GUI_ENABLE)
;~ 	_ArrayDisplay($aOutput)


EndFunc   ;==>ComposeCode

Func itsOwnFuncReturn($sObj, $sPropertyName, ByRef $aOutput)
	Local $n
	For $n = 1 To $aOutput[0][0]
		If StringStripWS($aOutput[$n][1], 3) = StringStripWS($sPropertyName, 3) Then
			If (Int($aOutput[$n][0]) <> 2 And Int($aOutput[$n][0]) <> 3) Then ContinueLoop
			If (Int($aOutput[$n][6]) And Int($aOutput[$n][8]) And ($aOutput[$n][1] <> "")) Then
				$aOutput[0][10] = $aOutput[0][10] & $aOutput[$n][10] & @CRLF
				If $aOutput[$n][9] = "" Then
					Return $sObj & $sPropertyName & ' ; did not build a function due to ValueMap <> Values'
				Else
					Return $aOutput[$n][9] & '( ' & $sObj & $sPropertyName & ' )'
				EndIf
			Else
				Return $sObj & $sPropertyName
			EndIf
		EndIf
	Next
	Return ; $sObj&$sPropertyName
EndFunc   ;==>itsOwnFuncReturn

Func niceSpacing($s, $i = 2) ; give a minimum space
	While StringLen($s) < $i
		$s = " " & $s
	WEnd
	Return $s
EndFunc   ;==>niceSpacing

; ********************************************************************
; * RunScript
; ********************************************************************
Func RunScript()
	;'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	; Create a temporary script file named "ScriptOMatic.temp.au3".
	;'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

	Local $sTmpName = @TempDir & "\ScriptOMatic.temp.au3"

	If FileExists($sTmpName) Then FileDelete($sTmpName)
	Local $g_idAST_ScriptCode_Str = GUICtrlRead_Sci($g_idAST_ScriptCode)

;	If @AutoItVersion = "3.2.12.1" Then ; these changes are for the temp.au3 running script. Are of no use in the editbox code.  ; for v3.2 start
;		If $_ArrayDisplay_Override_Topmost Then $g_idAST_ScriptCode_Str = "Global $_ArrayDisplay_Override_Topmost = 1 ; only for the ANSI compiled version" & @CRLF & $g_idAST_ScriptCode_Str
;		If $_ArrayDisplay_Override_PreferredMonitor Then $g_idAST_ScriptCode_Str = "Global $_ArrayDisplay_Override_PreferredMonitor = " & $_ArrayDisplay_Override_PreferredMonitor & " ; only for the ANSI compiled version" & @CRLF & $g_idAST_ScriptCode_Str
;		If _mm__GetMonitorFromPoint() > 1 Or $_ArrayDisplay_Override_PreferredMonitor Then ; support for multiple monitor setup ; function is in "Array.au3" v3.2.x.x from the ANSI compile
;			If @Compiled Then
;				If Not StringInStr($g_idAST_ScriptCode_Str, '#include "Array.au3"') Then $g_idAST_ScriptCode_Str = '#include "Array.au3"' & @CRLF & $g_idAST_ScriptCode_Str
;			Else
;				If Not StringInStr($g_idAST_ScriptCode_Str, '#include <Array.au3>') Then $g_idAST_ScriptCode_Str = '#include <Array.au3>' & @CRLF & $g_idAST_ScriptCode_Str
;			EndIf
;			$g_idAST_ScriptCode_Str = StringReplace($g_idAST_ScriptCode_Str, "ToolTip", "_mm__ToolTip")
;		EndIf
;	EndIf ; for v3.2 end

	FileWrite($sTmpName, $g_idAST_ScriptCode_Str)

	;'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	; Start constructing the command line that will run the script...
	;'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	Local $sCmdLine = '"' & @AutoItExe & '" "' & $sTmpName & '"'
	If @Compiled Then $sCmdLine = '"' & @AutoItExe & '" /AutoIt3ExecuteScript "' & $sTmpName & '"'

	Local $iPid = Run($sCmdLine)

	If StringInStr($g_idAST_ScriptCode_Str, "FileWriteLine(") Or StringInStr($g_idAST_ScriptCode_Str, "FileWrite(") Then $iCreatedTempFiles = 1

	;FileDelete($sTmpName)
	Return $iPid
EndFunc   ;==>RunScript

; ********************************************************************
; * SaveScript
; ********************************************************************
Func SaveScript($iRunEditor = 0)
	Local $sTmpName = FileSaveDialog("Save Script", $sSaveFile_InitDir, "AutoIt3 Scripts (*.au3)", 16, "ScriptOMatic." & GUICtrlReadStripExtra($g_idWMI_Classes) & ".au3")
	If Not @error And $sTmpName <> "" Then
		If StringRight($sTmpName, 4) <> ".au3" Then $sTmpName = $sTmpName & ".au3"
		If FileExists($sTmpName) Then FileDelete($sTmpName)
		FileWrite($sTmpName, GUICtrlRead_Sci($g_idAST_ScriptCode))
		$sSaveFile_InitDir = @WorkingDir
		If FileExists($ini) Then IniWrite($ini, "Settings", "SaveFile_InitDir", $sSaveFile_InitDir)
		If $iRunEditor Then
			If $aUserEditor[0] = 0 Then
				ShellExecute($sTmpName, "", $sSaveFile_InitDir, "Edit")
			Else
				Local $sRun = '"' & Execute($aUserEditor[1]) & '" "' & $sTmpName & '"'
				Run($sRun, @ScriptDir)
				GUICtrlSetData_Sci($g_idAST_ScriptCode, ';Editor Debug: >' & $sRun & '<' & @CRLF & ";Editor Debug: Editor Exists = " & FileExists(Execute($aUserEditor[1])) & @CRLF & @CRLF & GUICtrlRead_Sci($g_idAST_ScriptCode))
			EndIf
		EndIf
	EndIf
EndFunc   ;==>SaveScript

; ********************************************************************
; * OpenScript
; ********************************************************************

Func OpenScript()
	Local $sTmpName = FileOpenDialog("Open Script", $sSaveFile_InitDir, "AutoIt3 Scripts (*.au3)")

	If Not @error And $sTmpName <> "" Then
		If FileExists($sTmpName) Then
			GUICtrlSetData_Sci($g_idAST_ScriptCode, FileRead($sTmpName, FileGetSize($sTmpName)))
		EndIf
	EndIf
EndFunc   ;==>OpenScript

; ****************************************************************************
; * SetNamespaceToCIMV2
; ****************************************************************************
Func SetNamespaceToCIMV2()
	If GUICtrlRead($g_idWMI_Namespace) <> "root\CIMV2" Then
		If Not StringInStr($sNamespacesCombo, "root\CIMV2") Then
			GUICtrlSetData($g_idWMI_Namespace, "root\CIMV2|root\WMI|root\DEFAULT", "root\CIMV2")
		Else
			GUICtrlSetData($idAST_CIMv2, "W&MI")
			GUICtrlSetData($g_idWMI_Namespace, $sNamespacesCombo, "root\CIMV2")
		EndIf
		_GUICtrlComboBox_SetDroppedWidth($g_idWMI_Namespace, 500)
		HandleNamespaceChange()
		HandleNamespaceChange()
	Else
		If GUICtrlRead($g_idWMI_Namespace) = "root\CIMV2" Then
			GUICtrlSetData($g_idWMI_Namespace, $sNamespacesCombo, "root\WMI")
			GUICtrlSetData($idAST_CIMv2, "CI&Mv2")
			_GUICtrlComboBox_SetDroppedWidth($g_idWMI_Namespace, 500)
			HandleNamespaceChange()
			HandleNamespaceChange()
		EndIf
	EndIf
EndFunc   ;==>SetNamespaceToCIMV2

; ****************************************************************************
; * SetWMIRepository
; ****************************************************************************
Func SetWMIRepository()
	Local $sWMISourceName = InputBox("Set WMI Repository Source", _
			"Please enter the computer whose WMI repository you want to read from: " & @CR & @CR & _
			"(this code is not ready for remote connections yet)", _
			$g_sWMISource)
	If $sWMISourceName <> "" Then
		If Execute($sWMISourceName) <> "" Then $sWMISourceName = Execute($sWMISourceName)
		$g_sWMISource = StringStripWS($sWMISourceName, 1 + 2)
		;target_computers.Value = $g_sWMISource
		;	LoadWMINamespaces()
		;	HandleNamespaceChange() ; i should reload, but this was not set here (note to self)
	EndIf
	If Not Ping($g_sWMISource) Then
		GUICtrlSetData_Sci($g_idAST_ScriptCode, "oops !" & @CRLF & @CRLF & 'Ping failed on "' & $g_sWMISource & '"' & @CRLF & @CRLF & _
				'so back to "localhost" (this code is not ready for remote PCs yet anyway)')
		$g_sWMISource = "localhost"
	Else
		;HandleNamespaceChange() ; but it is buggy as is
	EndIf
EndFunc   ;==>SetWMIRepository

; ****************************************************************************
; * HandleOutputChange
; ****************************************************************************
Func HandleOutputChange()
	Local $sChosenFormat = $g_sOutputFormat
	If GUICtrlRead($g_idAST_RadioDialog) = $GUI_CHECKED Then $sChosenFormat = "Dialog"
	If GUICtrlRead($g_idAST_RadioText) = $GUI_CHECKED Then $sChosenFormat = "Text"
	If GUICtrlRead($g_idAST_RadioHTML) = $GUI_CHECKED Then $sChosenFormat = "HTML"
	If GUICtrlRead($g_idAST_RadioArray) = $GUI_CHECKED Then $sChosenFormat = "Array"
;~ 	If $sChosenFormat <> $g_sOutputFormat Then
	$g_sOutputFormat = $sChosenFormat
	ComposeCode()
;~ 	EndIf
EndFunc   ;==>HandleOutputChange

; ****************************************************************************
; * LookupWeb
; ****************************************************************************
Func LookupWeb()
	Local $sSelectedClass = GUICtrlReadStripExtra($g_idWMI_Classes)

	; Check If a valid class has been selected
	If $sSelectedClass <> "Select a WMI class" Then
		;	Run(@ComSpec & " /c start http://msdn.microsoft.com/library/en-us/wmisdk/wmi/" & $sSelectedClass & ".asp?frame=true", "", @SW_HIDE)	; ..this goes nowhere now
		Run(@ComSpec & " /c start " & StringReplace($sGoogleIt, "@SelectedClass", $sSelectedClass), @TempDir, @SW_HIDE) ; so we Google it
		Sleep(2000)
	EndIf
EndFunc   ;==>LookupWeb

; to select the text in the Edit control without using more includes
Func _GUICtrl_Edit_SetSel($hWnd, $iStart = 0, $iEnd = -1)
	If Not IsHWnd($hWnd) Then $hWnd = GUICtrlGetHandle($hWnd)
	_SendMessage($hWnd, 0xB1, $iStart, $iEnd) ; $EM_SETSEL = 0xB1
EndFunc   ;==>_GUICtrl_Edit_SetSel

Func Func_Array_Rotate2D($TAB = "    ")
	Local $sOut = ""
	$sOut &= 'Func _Array_Rotate2D(ByRef $a)' & @CRLF
	$sOut &= $TAB & 'Local $u1 = UBound($a, 1) - 1' & @CRLF
	$sOut &= $TAB & 'If @error Then Return SetError(1)' & @CRLF
	$sOut &= $TAB & 'Local $u2 = UBound($a, 2) - 1' & @CRLF
	$sOut &= $TAB & 'If @error Then' & @CRLF
	$sOut &= $TAB & $TAB & 'Local $n, $m, $u2 = 1' & @CRLF
	$sOut &= $TAB & $TAB & 'Local $b[$u2][$u1 + 1]' & @CRLF
	$sOut &= $TAB & $TAB & 'For $n = 0 To $u1' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'For $m = 0 To 0' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & '$b[$m][$n] = $a[$n]' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & 'Else' & @CRLF
	$sOut &= $TAB & $TAB & 'Local $n, $m' & @CRLF
	$sOut &= $TAB & $TAB & 'Local $b[$u2 + 1][$u1 + 1]' & @CRLF
	$sOut &= $TAB & $TAB & 'For $n = 0 To $u1' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'For $m = 0 To $u2' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & '$b[$m][$n] = $a[$n][$m]' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & '$a = $b' & @CRLF
	$sOut &= 'EndFunc   ;==>_Array_Rotate2D' & @CRLF
	Return $sOut
EndFunc   ;==>Func_Array_Rotate2D

Func Func_Array_Join($TAB = '   ')
	Local $sOut = "" & @CRLF
	$sOut &= 'Func Array_Join($aArray, $sSeparator = " , ")' & @CRLF
	$sOut &= $TAB & 'Local $n, $sOut = ""' & @CRLF
	$sOut &= $TAB & 'If IsObj($aArray) Then' & @CRLF
	$sOut &= $TAB & $TAB & 'For $value In $aArray' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & '$sOut &= $value & $sSeparator' & @CRLF
	$sOut &= $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & $TAB & 'Return StringTrimRight($sOut, StringLen($sSeparator))' & @CRLF
	$sOut &= $TAB & 'Else' & @CRLF
	$sOut &= $TAB & $TAB & 'For $n = 0 To UBound($aArray) - 1' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & '$sOut &= $aArray[$n] & $sSeparator' & @CRLF
	$sOut &= $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & $TAB & 'Return StringTrimRight($sOut, StringLen($sSeparator))' & @CRLF
	$sOut &= $TAB & 'EndIf' & @CRLF
	$sOut &= 'EndFunc   ;==>Array_Join' & @CRLF
	Return $sOut
EndFunc   ;==>Func_Array_Join

Func Func_Array2D_toHtml($TAB = "    ")
	Local $sOut = "" & @CRLF
	$sOut &= 'Func _Array2D_toHtml(ByRef $a, $orientation = 0, $sSelectedClass = "")' & @CRLF
	$sOut &= $TAB & 'Local $u1 = UBound($a, 1) - 1' & @CRLF
	$sOut &= $TAB & 'If @error Then Return SetError(1, 1, "")' & @CRLF
	$sOut &= $TAB & "Local $sOut = '<html><head><meta http-equiv=""Content-Type"" content=""text/html; charset=windows-1252""><title>ScriptOMatic - ' & $sSelectedClass & '</title></head><body bgcolor=""#EEEEEE"">'" & @CRLF
	$sOut &= $TAB & '$sOut &= $sSelectedClass' & @CRLF
	$sOut &= $TAB & "$sOut &= '<br><br><table border=""1"" width=""100%"" cellspacing=""0"">' & @CRLF" & @CRLF
	$sOut &= $TAB & 'Local $iFlipFlop = True' & @CRLF
	$sOut &= $TAB & "Local $aFlipFlop[2] = ['" & $a2h_td1 & "', '" & $a2h_td2 & "']" & @CRLF
	$sOut &= $TAB & 'Local $headderItStart = "", $headderItEnd = ""' & @CRLF
	$sOut &= $TAB & 'Local $u2 = UBound($a, 2) - 1' & @CRLF
	$sOut &= $TAB & 'If @error Then' & @CRLF
	$sOut &= $TAB & $TAB & 'Local $n, $m, $u2 = 1' & @CRLF
	$sOut &= $TAB & $TAB & 'Local $b[$u2][$u1 + 1]' & @CRLF
	$sOut &= $TAB & $TAB & 'For $n = 0 To $u1' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & '$sOut &= "<tr>"' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'If Not $orientation Then' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & '$iFlipFlop = Not $iFlipFlop' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'Else' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'If Not $n Then' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItStart = "<i><u>"' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItEnd = "</u></i>"' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'Else' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItStart = ""' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItEnd = ""' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'For $m = 0 To 0' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'If $orientation Then' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & 'If Not $m Then' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & $TAB & '$iFlipFlop = True' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & '$iFlipFlop = Not $iFlipFlop' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'Else' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & 'If Not $m Then' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItStart = "<i><u>"' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItEnd = "</u></i>"' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & 'Else' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItStart = ""' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItEnd = ""' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & "$sOut &= '<td ' & $aFlipFlop[($iFlipFlop)] & '>' & $headderItStart & $a[$n] & $headderItEnd & '</td>'" & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & '$sOut &= "</tr>" & @CRLF' & @CRLF
	$sOut &= $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & 'Else' & @CRLF
	$sOut &= $TAB & $TAB & 'Local $n, $m' & @CRLF
	$sOut &= $TAB & $TAB & 'Local $b[$u2 + 1][$u1 + 1]' & @CRLF
	$sOut &= $TAB & $TAB & 'For $n = 0 To $u1' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & '$sOut &= "<tr>"' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'If Not $orientation Then' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & '$iFlipFlop = Not $iFlipFlop' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'Else' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'If Not $n Then' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItStart = "<b>"' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItEnd = "</b>"' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'Else' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItStart = ""' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItEnd = ""' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'For $m = 0 To $u2' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'If $orientation Then' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & 'If Not $m Then' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & $TAB & '$iFlipFlop = True' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & '$iFlipFlop = Not $iFlipFlop' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'Else' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & 'If Not $m Then' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItStart = "<b>"' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItEnd = "</b>"' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & 'Else' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItStart = ""' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & $TAB & '$headderItEnd = ""' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & "$sOut &= '<td ' & $aFlipFlop[($iFlipFlop)] & '>' & $headderItStart & $a[$n][$m] & $headderItEnd & '</td>'" & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & '$sOut &= "</tr>" & @CRLF' & @CRLF
	$sOut &= $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & '$sOut &= "</table>" & @CRLF' & @CRLF
	$sOut &= $TAB & "$sOut &= '</body></html>' & @CRLF" & @CRLF
	$sOut &= $TAB & 'Return SetError(0, 0, $sOut)' & @CRLF
	$sOut &= 'EndFunc   ;==>_Array2D_toHtml' & @CRLF
	Return $sOut
EndFunc   ;==>Func_Array2D_toHtml

Func setSettings($hParent = 0)

	Local $iPosX = -1, $iPosY = -1, $iPosW = 0, $iPosH = 0
	If $hParent Then
		GUISetState(@SW_DISABLE, $hParent)
		Local $hParentPos = WinGetPos($hParent)
		$iPosX = $hParentPos[0]
		$iPosY = $hParentPos[1]
		$iPosW = $hParentPos[2]
		$iPosH = $hParentPos[3]
	EndIf

	Local $n, $s
	Local $sett_Form, $sett_Font_label, $sett_save_Button, $sett_removem_Button, $sett_HTML_Group, $sett_a2h_td_Str_Input1, $sett_a2h_td_Str_Input2
	Local $sett_a2h_td_Str_Reset_Button, $sett_tab_Label, $sett_tab_size_Combo, $sett_onExit_temp_Group, $sett_RemoveTempFiles_Ask_Radio, $sett_RemoveTempFiles_remove_Radio
	Local $sett_RemoveTempFiles_dontTouch_Radio, $sett_font_Button, $sett_font_bg_Button, $sett_ArrDisp_Group, $sett_ArrDisp_Check
	Local $sett_mm_Label = 0, $sett_mm_Label2 = 0, $sett_mm_Combo = 0
	Local $sett_remTemp_Ask_Radio, $sett_remTemp_remove_Radio, $sett_remTemp_dontTouch_Radio
	Local $sett_cache_Group, $sett_cache_clear_classes_Button, $sett_portableRedyButton
	Local $sett_searchStr_Group, $sett_searchStr_Input, $sett_arrayLimit_Label, $sett_arrayLimit_Input
	Local $sett_editor_Input, $sett_editor_Group, $sett_editor_Chb, $sett_editor_InputPreview, $sett_DynamicClassOnly_Checkbox


	$sett_Form = GUICreate("Settings", 332, 566, $iPosX + $iPosW - 327 - 80, $iPosY + 12, -1, BitOR($WS_EX_TOOLWINDOW, $WS_EX_TOPMOST, $WS_EX_WINDOWEDGE))
	$sett_Font_label = GUICtrlCreateLabel("Font: ", 14, 14, 39, 17, $SS_RIGHT)
	$sett_save_Button = GUICtrlCreateButton("Save to disk", 22, 533, 83, 23, $BS_NOTIFY)
	$sett_removem_Button = GUICtrlCreateButton("remove settings file from disk", 121, 533, 171, 23, $BS_NOTIFY)
	$sett_HTML_Group = GUICtrlCreateGroup("Array to Html < td 'your string' > ", 14, 453, 297, 65, BitOR($GUI_SS_DEFAULT_GROUP, $BS_CENTER))
	$sett_a2h_td_Str_Input1 = GUICtrlCreateInput("", 24, 468, 209, 21, $GUI_SS_DEFAULT_INPUT)
	$sett_a2h_td_Str_Input2 = GUICtrlCreateInput("", 24, 492, 209, 21, $GUI_SS_DEFAULT_INPUT)
	$sett_a2h_td_Str_Reset_Button = GUICtrlCreateButton("RESET", 243, 470, 59, 41, BitOR($BS_DEFPUSHBUTTON, $BS_MULTILINE, $BS_NOTIFY))
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$sett_tab_Label = GUICtrlCreateLabel("Tab size: ", 13, 78, 58, 17, $SS_RIGHT)
	$sett_tab_size_Combo = GUICtrlCreateCombo("", 75, 75, 57, 400, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
	$sett_onExit_temp_Group = GUICtrlCreateGroup("OnExit - remove temp. files", 168, 56, 149, 81)
	$sett_remTemp_Ask_Radio = GUICtrlCreateRadio("Ask", 178, 72, 113, 17)
	GUICtrlSetState(-1, $GUI_CHECKED)
	$sett_remTemp_remove_Radio = GUICtrlCreateRadio("Remove", 178, 91, 115, 17)
	$sett_remTemp_dontTouch_Radio = GUICtrlCreateRadio("Don't Touch", 178, 111, 113, 17)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$sett_font_Button = GUICtrlCreateButton("font to use in the edit box", 57, 6, 259, 31, $BS_NOTIFY)
	$sett_font_bg_Button = GUICtrlCreateButton("font's bg color", 16, 43, 137, 28)
	$sett_ArrDisp_Group = GUICtrlCreateGroup(" _ArrayDisplay ", 47, 104, 89, 41)
	$sett_ArrDisp_Check = GUICtrlCreateCheckbox("Topmost", 57, 121, 69, 17)
	GUICtrlSetTip(-1, "set default topmost ( ANSI version only)")
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$sett_mm_Label = GUICtrlCreateLabel(" Show _ArrayDisplay in monitor # ", 24, 160, 162, 17)
	$sett_mm_Combo = GUICtrlCreateCombo("", 188, 156, 49, 400, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
	$sett_mm_Label2 = GUICtrlCreateLabel("( set to 0 to display in current monitor )", 32, 180, 182, 17)
	$sett_cache_Group = GUICtrlCreateGroup("Cache", 12, 400, 308, 49, BitOR($GUI_SS_DEFAULT_GROUP, $BS_CENTER))
	$sett_cache_clear_classes_Button = GUICtrlCreateButton("clear Namespaces and Classes", 20, 416, 291, 23)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$sett_searchStr_Group = GUICtrlCreateGroup(" full search string: ", 12, 232, 308, 41)
	$sett_searchStr_Input = GUICtrlCreateInput("https://www.google.com/search?q=msdn+wmi+%22@SelectedClass%22+example", 20, 248, 289, 21)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$sett_arrayLimit_Label = GUICtrlCreateLabel(" Array limit: ", 16, 286, 57, 17, $SS_RIGHT)
	$sett_arrayLimit_Input = GUICtrlCreateInput("1000", 74, 283, 73, 21, BitOR($GUI_SS_DEFAULT_INPUT, $ES_CENTER))
	$sett_portableRedyButton = GUICtrlCreateButton("move settings to local folder for portable use", 194, 279, 123, 37, $BS_MULTILINE)
	$sett_editor_Group = GUICtrlCreateGroup(" Editor to use in portable mode: ", 12, 319, 308, 73)
	$sett_editor_Input = GUICtrlCreateInput("@ScriptDir & ""\..\..\SciTE\SciTE.exe""", 20, 347, 289, 21)
	$sett_editor_Chb = GUICtrlCreateCheckbox("use this editor", 220, 327, 97, 19, BitOR($GUI_SS_DEFAULT_CHECKBOX, $BS_PUSHLIKE))
	$sett_editor_InputPreview = GUICtrlCreateInput("@ScriptDir & ""\..\..\SciTE\SciTE.exe""", 20, 368, 289, 21, BitOR($GUI_SS_DEFAULT_INPUT, $ES_READONLY))
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$sett_DynamicClassOnly_Checkbox = GUICtrlCreateCheckbox("Show only Dynamic Class", 16, 208, 289, 17)
	GUICtrlSetTip(-1, "changing this will clear the cache for classes")



;	If @AutoItVersion = "3.2.12.1" Then ; for v3.2 start
;		$s = ''
;		For $n = 0 To UBound($_mm__MonitorList) - 1
;			If $n Then $s &= '|'
;			$s &= $n
;		Next
;		GUICtrlSetData($sett_mm_Combo, $s, $_ArrayDisplay_Override_PreferredMonitor)
;		GUICtrlSetTip($sett_mm_Label, "( ANSI version only)")
;		GUICtrlSetTip($sett_mm_Label2, "( ANSI version only)")
;		GUICtrlSetTip($sett_mm_Combo, "( ANSI version only)")
;		If $_ArrayDisplay_Override_Topmost Then GUICtrlSetState($sett_ArrDisp_Check, $GUI_CHECKED)
;
;		$s = ''
;		For $n = 0 To UBound($_mm__MonitorList) - 1
;			If $n Then $s &= '|'
;			$s &= $n
;		Next
;
;	Else ; for v3.2 end
		GUICtrlSetState($sett_mm_Label, $GUI_HIDE)
		GUICtrlSetState($sett_mm_Label2, $GUI_HIDE)
		GUICtrlSetState($sett_mm_Combo, $GUI_HIDE)
		GUICtrlSetState($sett_ArrDisp_Group, $GUI_HIDE)
		GUICtrlSetState($sett_ArrDisp_Check, $GUI_HIDE)
;	EndIf ; for v3.2

	GUICtrlSetState($sett_portableRedyButton, $GUI_DISABLE)
	If FileExists($ini) Then GUICtrlSetState($sett_portableRedyButton, $GUI_ENABLE)
	If $ini = @ScriptDir & '\ScriptOMatic.ini' Then GUICtrlSetData($sett_portableRedyButton, "move settings back to @AppDataDir folder")

	If $ShowOnlyDynamicClasses Then GUICtrlSetState($sett_DynamicClassOnly_Checkbox, $GUI_CHECKED)

	If IniRead($ini, "Settings", "Editor", "") = "" Then
		GUICtrlSetState($sett_editor_Input, $GUI_DISABLE)
		GUICtrlSetData($sett_editor_Input, IniRead($ini, "Settings", "#~ Editor", "@ScriptDir & ""\..\..\SciTE\SciTE.exe"""))
	Else
		GUICtrlSetState($sett_editor_Chb, $GUI_CHECKED)
		GUICtrlSetData($sett_editor_Input, IniRead($ini, "Settings", "Editor", ""))
	EndIf
	$aUserEditor[2] = GUICtrlRead($sett_editor_Input)
	GUICtrlSetData($sett_editor_InputPreview, "Preview: >" & Execute($aUserEditor[2]) & "<")

	GUICtrlSetData($sett_a2h_td_Str_Input1, $a2h_td1)
	GUICtrlSetData($sett_a2h_td_Str_Input2, $a2h_td2)

	Switch $sett_RemoveTempFiles
		Case 1
			GUICtrlSetState($sett_RemoveTempFiles_remove_Radio, $GUI_CHECKED)
		Case 2
			GUICtrlSetState($sett_RemoveTempFiles_dontTouch_Radio, $GUI_CHECKED)
		Case Else
			GUICtrlSetState($sett_RemoveTempFiles_Ask_Radio, $GUI_CHECKED)
	EndSwitch

	setSettings_refreshRemoveSettingsFileButton($sett_removem_Button)

	_fontCtrlSet($g_idAST_ScriptCodeFont, $sett_font_Button)
	_fontCtrlSet($g_idAST_ScriptCodeFont, $sett_font_bg_Button, 1)

	GUICtrlSetData($sett_tab_size_Combo, "0|1|2|3|4|5|6|7|8|9|10|11|12", $iTab)


	Local $iAccelKey_ESC = GUICtrlCreateButton("Exit", 1, 2, 3, 2, $BS_NOTIFY)
	GUICtrlSetState($iAccelKey_ESC, $GUI_HIDE)
	Local $aAccelKeys[1][2] = [["{ESC}", $iAccelKey_ESC]]
	GUISetAccelerators($aAccelKeys)

	GUISetState(@SW_SHOW)
	Local $nMsg, $n
	Local $iHandleNamespaceChange = 0
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE, $iAccelKey_ESC
				$a2h_td1 = GUICtrlRead($sett_a2h_td_Str_Input1)
				$a2h_td2 = GUICtrlRead($sett_a2h_td_Str_Input2)
				$sGoogleIt = GUICtrlRead($sett_searchStr_Input)
				$iArrayDefaultLimit = Int(GUICtrlRead($sett_arrayLimit_Input))
				$aUserEditor[1] = GUICtrlRead($sett_editor_Input)
				If $ShowOnlyDynamicClasses <> __Iif(GUICtrlRead($sett_DynamicClassOnly_Checkbox) = 1, 1, 0) Then
					$ShowOnlyDynamicClasses = __Iif(GUICtrlRead($sett_DynamicClassOnly_Checkbox) = 1, 1, 0)
					FileDelete($sCacheFileBaseName & '*')
					$iHandleNamespaceChange = 1
				EndIf
				ExitLoop

			Case $sett_DynamicClassOnly_Checkbox
				;	ConsoleWrite( "$sett_editor_Input = "& __Iif( GUICtrlRead($sett_DynamicClassOnly_Checkbox) = 1 , 1 , 0 ) &@CRLF )

			Case $sett_editor_Chb
				If GUICtrlRead($sett_editor_Chb) = 1 Then
					GUICtrlSetState($sett_editor_Input, $GUI_ENABLE)
					$aUserEditor[0] = 1
				Else
					GUICtrlSetState($sett_editor_Input, $GUI_DISABLE)
					$aUserEditor[0] = 0
				EndIf

			Case $sett_portableRedyButton
				GUICtrlSetState($nMsg, $GUI_DISABLE)
				Switch $ini
					Case @AppDataDir & '\ScriptOMaticForAutoIt3\ScriptOMatic.ini'
						FileMove(@AppDataDir & '\ScriptOMaticForAutoIt3\ScriptOMatic.ini', @ScriptDir & '\')
						FileMove(@AppDataDir & '\ScriptOMaticForAutoIt3\ScriptOMatic.cache.*', @ScriptDir & '\cache\', 9)
						GUICtrlSetData($sett_portableRedyButton, "move settings back to @AppDataDir folder")
						$ini = @ScriptDir & '\ScriptOMatic.ini'
						DirRemove(@AppDataDir & '\ScriptOMaticForAutoIt3')
					Case @ScriptDir & '\ScriptOMatic.ini'
						If FileExists(@ScriptDir & '\ScriptOMatic.ini') Then
							FileMove(@AppDataDir & '\ScriptOMaticForAutoIt3\ScriptOMatic.ini', @ScriptDir & '\')
							FileMove(@ScriptDir & '\cache\*', @AppDataDir & '\ScriptOMaticForAutoIt3\', 9)
							FileMove(@ScriptDir & '\ScriptOMatic.ini', @AppDataDir & '\ScriptOMaticForAutoIt3\', 9)
						EndIf
						GUICtrlSetData($sett_portableRedyButton, "move settings to local folder for portable use")
						$ini = @AppDataDir & '\ScriptOMaticForAutoIt3\ScriptOMatic.ini'
						DirRemove(@ScriptDir & '\cache')
				EndSwitch
				Sleep(500)
				GUICtrlSetState($nMsg, $GUI_ENABLE)

			Case $sett_ArrDisp_Check
				If GUICtrlRead($sett_ArrDisp_Check) = 1 Then
					$_ArrayDisplay_Override_Topmost = 1
				Else
					$_ArrayDisplay_Override_Topmost = 0
				EndIf

			Case $sett_cache_clear_classes_Button
				GUICtrlSetState($nMsg, $GUI_DISABLE)
				FileDelete($sCacheFileBaseName & '*')
				Sleep(400)
				GUICtrlSetState($nMsg, $GUI_ENABLE)

			Case $sett_mm_Combo
				$_ArrayDisplay_Override_PreferredMonitor = Int(GUICtrlRead($sett_mm_Combo))

			Case $sett_font_Button
				GUICtrlSetState($nMsg, $GUI_DISABLE)
				GUICtrlSetState($sett_font_Button, $GUI_DISABLE)
				_fontSet($g_idAST_ScriptCodeFont, $sett_Form)
				_fontCtrlSet($g_idAST_ScriptCodeFont, $sett_font_Button)
				_fontCtrlSet($g_idAST_ScriptCodeFont, $g_idAST_ScriptCode, 1)
				GUICtrlSetColor($sett_font_bg_Button, $g_idAST_ScriptCodeFont[7])
				Sleep(200)
				GUICtrlSetState($nMsg, $GUI_ENABLE)

			Case $sett_save_Button
				GUICtrlSetState($nMsg, $GUI_DISABLE)
				_fontSetIni($g_idAST_ScriptCodeFont, "g_idAST_ScriptCode_font")
				IniWrite($ini, "Settings", "g_idAST_ScriptCode_Tab", $iTab)
				IniWrite($ini, "Settings", "g_idAST_ScriptCode_bg", $g_idAST_ScriptCode_bg)
				$a2h_td1 = GUICtrlRead($sett_a2h_td_Str_Input1)
				$a2h_td2 = GUICtrlRead($sett_a2h_td_Str_Input2)
				IniWrite($ini, "Settings", "array2html_bg1", $a2h_td1)
				IniWrite($ini, "Settings", "array2html_bg2", $a2h_td2)
				IniWrite($ini, "Settings", "sett_RemoveTempFiles", $sett_RemoveTempFiles)
				IniWrite($ini, "Settings", "ArrayDisplay_Override_Topmost", $_ArrayDisplay_Override_Topmost)
				IniWrite($ini, "Settings", "ArrayDisplay_Override_PreferredMonitor", $_ArrayDisplay_Override_PreferredMonitor)
				IniWrite($ini, "Settings", "sGoogleIt", GUICtrlRead($sett_searchStr_Input))
				IniWrite($ini, "Settings", "iArrayDefaultLimit", Int(GUICtrlRead($sett_arrayLimit_Input)))
				IniWrite($ini, "Settings", "ShowOnlyDynamicClasses", __Iif(GUICtrlRead($sett_DynamicClassOnly_Checkbox) = 1, 1, 0))
				IniDelete($ini, "Settings", "Editor")
				IniDelete($ini, "Settings", "#~ Editor")
				If GUICtrlRead($sett_editor_Chb) = 1 Then
					IniWrite($ini, "Settings", "Editor", GUICtrlRead($sett_editor_Input))
				Else
					IniWrite($ini, "Settings", "#~ Editor", GUICtrlRead($sett_editor_Input))
				EndIf
				Sleep(200)
				If StringInStr($sCacheFileBaseName, @TempDir) Then
					FileMove($sCacheFileBaseName & '*', @AppDataDir & '\ScriptOMaticForAutoIt3\')
					$sCacheFileBaseName = StringTrimRight($ini, 3) & "cache."
				EndIf

				setSettings_refreshRemoveSettingsFileButton($sett_removem_Button)
				If FileExists(@AppDataDir & '\ScriptOMaticForAutoIt3\ScriptOMatic.ini') Then GUICtrlSetState($sett_portableRedyButton, $GUI_ENABLE)
				GUICtrlSetState($nMsg, $GUI_ENABLE)

			Case $sett_a2h_td_Str_Reset_Button
				GUICtrlSetState($nMsg, $GUI_DISABLE)
				$a2h_td1 = 'bgcolor="#EAEAEA"'
				$a2h_td2 = 'bgcolor="#E2E2E2"'
				GUICtrlSetData($sett_a2h_td_Str_Input1, $a2h_td1)
				GUICtrlSetData($sett_a2h_td_Str_Input2, $a2h_td2)
				Sleep(200)
				GUICtrlSetState($nMsg, $GUI_ENABLE)

			Case $sett_removem_Button
				GUICtrlSetState($nMsg, $GUI_DISABLE)
				If FileExists(@AppDataDir & '\ScriptOMaticForAutoIt3\ScriptOMatic.ini') Then DirRemove(@AppDataDir & '\ScriptOMaticForAutoIt3', 1)
				Sleep(200)
				setSettings_refreshRemoveSettingsFileButton($sett_removem_Button)

			Case $sett_tab_size_Combo
				$iTab = Int(GUICtrlRead($sett_tab_size_Combo))
				$sTab = tabInt2Str($iTab)
				If StringInStr(GUICtrlRead_Sci($g_idAST_ScriptCode), "Generated by AutoIt ScriptOMatic") Then
					HandleOutputChange()
				Else
					redrawHelpStr()
				EndIf

			Case $sett_font_bg_Button
				Local $iChosenColor = _ChooseColor(2, $g_idAST_ScriptCode_bg, 2, $sett_Form)
				If $iChosenColor <> -1 Then
					$g_idAST_ScriptCode_bg = $iChosenColor
					GUICtrlSetBkColor($g_idAST_ScriptCode, $g_idAST_ScriptCode_bg)
					GUICtrlSetBkColor($sett_font_bg_Button, $g_idAST_ScriptCode_bg)
				EndIf
				GUICtrlSetState($nMsg, $GUI_ENABLE)

			Case $sett_RemoveTempFiles_Ask_Radio
				$sett_RemoveTempFiles = 0
			Case $sett_RemoveTempFiles_remove_Radio
				$sett_RemoveTempFiles = 1
			Case $sett_RemoveTempFiles_dontTouch_Radio
				$sett_RemoveTempFiles = 2

		EndSwitch
		If $aUserEditor[2] <> GUICtrlRead($sett_editor_Input) Then
			$aUserEditor[2] = GUICtrlRead($sett_editor_Input)
			GUICtrlSetData($sett_editor_InputPreview, "Preview: >" & Execute($aUserEditor[2]) & "<")
		EndIf

	WEnd

	GUIDelete($sett_Form)
	If $hParent Then
		GUISetState(@SW_ENABLE, $hParent)
		WinActivate($hParent)
	EndIf
	While GUIGetMsg()
	WEnd
	If $iHandleNamespaceChange Then
		HandleNamespaceChange()
		redrawHelpStr()
		GUICtrlSetState($g_idWMI_Classes, $GUI_ENABLE)
	EndIf

EndFunc   ;==>setSettings

; #FUNCTION# ====================================================================================================================
; Name...........: _Iif
; Description ...: Perform a boolean test within an expression.
; Syntax.........: _Iif($fTest, $vTrueVal, $vFalseVal)
; Parameters ....: $fTest     - Boolean test.
;                  $vTrueVal  - Value to return if $fTest is true.
;                  $vFalseVal - Value to return if $fTest is false.
; Return values .: True         - $vTrueVal
;                  False        - $vFalseVal
; Author ........: Dale (Klaatu) Thompson
; Modified.......:
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; Yes
; ===============================================================================================================================
Func __Iif($fTest, $vTrueVal, $vFalseVal)
	If $fTest Then
		Return $vTrueVal
	Else
		Return $vFalseVal
	EndIf
EndFunc   ;==>__Iif

Func setSettings_refreshRemoveSettingsFileButton(ByRef $sett_removem_Button)
	If Not FileExists(@AppDataDir & '\ScriptOMaticForAutoIt3\ScriptOMatic.ini') Then
		GUICtrlSetState($sett_removem_Button, $GUI_DISABLE)
	Else
		GUICtrlSetState($sett_removem_Button, $GUI_ENABLE)
	EndIf
EndFunc   ;==>setSettings_refreshRemoveSettingsFileButton

Func redrawHelpStr()
	Local $s = GUICtrlRead_Sci($g_idAST_ScriptCode)
	Local $a = StringSplit($s, @CRLF, 1)
	$s = ""
	For $n = 1 To $a[0]
		If StringInStr($a[$n], " = ") Or StringInStr($a[$n], "failed") Or StringInStr($a[$n], 'try "Run as ') Then
			$s &= $sTab & StringStripWS($a[$n], 3)
			If $n < $a[0] Then $s &= @CRLF
		Else
			$s &= $a[$n]
			If $n < $a[0] Then $s &= @CRLF
		EndIf
	Next
	GUICtrlSetData_Sci($g_idAST_ScriptCode, $s, "")
EndFunc   ;==>redrawHelpStr

Func tabInt2Str(ByRef $iTab)
	Local $sTab = ""
	For $n = 1 To $iTab
		$sTab &= " "
	Next
	Return $sTab
EndFunc   ;==>tabInt2Str

Func _fontCtrlSet(ByRef $aFont, $hGUICtrl, $iSetColor = 0)
	_fontSetArray($aFont)
	GUICtrlSetFont($hGUICtrl, $aFont[3], $aFont[4], $aFont[1], $aFont[2])
	If $iSetColor Then GUICtrlSetColor($hGUICtrl, $aFont[7])
EndFunc   ;==>_fontCtrlSet

Func _fontGetIni(ByRef $aFont, $sEntry)
	$aFont = StringSplit(IniRead($ini, "Settings", $sEntry, "0|Lucida Console|10|0|0|0|0"), "|")
EndFunc   ;==>_fontGetIni

Func _fontSetIni(ByRef $aFont, $sEntry)
	Local $n, $s = "", $u1 = UBound($aFont) - 1
	For $n = 1 To $u1
		If $n > 1 Then $s &= '|'
		$s &= $aFont[$n]
	Next
	If Not FileExists($ini) Then
		DirCreate(@AppDataDir & '\ScriptOMaticForAutoIt3')
	EndIf
	IniWrite($ini, "Settings", $sEntry, $s)
EndFunc   ;==>_fontSetIni

Func _fontSetArray(ByRef $aFont)
	If UBound($aFont) = 8 Then Return
	Dim $aFont[8]
	$aFont[0] = UBound($aFont) - 1
	$aFont[1] = 0 ; attributes = BitOR of italic:2, undeline:4, strikeout:8
	$aFont[2] = "Verdana" ; "Courier New" ; fontname
	$aFont[3] = 10 ; font size = point size
	$aFont[4] = 0 ; font weight = = 0-1000
	$aFont[5] = 0 ; COLORREF rgbColors
	$aFont[6] = 0 ; Hex BGR Color
	$aFont[7] = 0 ; Hex RGB Color
EndFunc   ;==>_fontSetArray

Func _fontSet(ByRef $aFont, $hWndOwner = 0)
	_fontSetArray($aFont)
;~ _ChooseFont ( [$sFontName = "Courier New" [, $iPointSize = 10 [, $iColorRef = 0 [, $iFontWeight = 0 [, $bItalic = False [, $bUnderline = False [, $bStrikethru = False [, $hWndOwner = 0]]]]]]]] )
	SetError(0)
	Local $sFontName = $aFont[2]
	Local $iFontSize = $aFont[3]
	Local $iColorRef = $aFont[5]
	Local $iFontWeight = $aFont[4]
	Local $bItalic = BitAND($aFont[1], 2)
	Local $bUnderline = BitAND($aFont[1], 4)
	Local $bStrikethru = BitAND($aFont[1], 8)
	Local $aChosenFont = _ChooseFont($sFontName, $iFontSize, $iColorRef, $iFontWeight, $bItalic, $bUnderline, $bStrikethru, $hWndOwner)
	If (@error) Then
		;	MsgBox($MB_SYSTEMMODAL, "", "Error _ChooseFont: " & @error)
	Else
		$aFont = $aChosenFont
;~ 		MsgBox($MB_SYSTEMMODAL, "", "Font Name: " & $aFont[2] & @CRLF & _
;~ 				"Size: " & $aFont[3] & @CRLF & _
;~ 				"Weight: " & $aFont[4] & @CRLF & _
;~ 				"COLORREF rgbColors: " & $aFont[5] & @CRLF & _
;~ 				"Hex BGR Color: " & $aFont[6] & @CRLF & _
;~ 				"Hex RGB Color: " & $aFont[7] & @CRLF & _
;~ 				"$bItalic: " & BitAND($aFont[1], 2) & @CRLF & _
;~ 				"$bUnderline: " & BitAND($aFont[1], 4) & @CRLF & _
;~ 				"$bStrikethru: " & BitAND($aFont[1], 8) & @CRLF & _
;~ 				"")
	EndIf
	Return SetError(@error)
EndFunc   ;==>_fontSet


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; excerpt from "CSnippet.au3"
Func _InsertIntoScite($DataToInsert, $iOpenNewTab = 0)
	If Not WinExists("[CLASS:SciTEWindow;]", "") Then Return 1
	;----------------------------------------------------------------------------------------------
	;If $DebugIt Then _DebugPrint ('_InsertIntoScite-->' & $DataToInsert)
	;----------------------------------------------------------------------------------------------
	Opt("WinSearchChildren", 1)
	Local $Scite_hwnd = WinGetHandle("DirectorExtension")
	WinActivate("[CLASS:SciTEWindow;]", "") ; ..because you're gonna use it.
	$DataToInsert = StringReplace($DataToInsert, "\", "\\")
	$DataToInsert = StringReplace($DataToInsert, @TAB, "\t")
	$DataToInsert = StringReplace($DataToInsert, @CR, "\r")
	$DataToInsert = StringReplace($DataToInsert, @LF, "\n")
	If $iOpenNewTab Then
		_SciTE_Send_Command(0, $Scite_hwnd, "open:")
		Sleep(100)
	EndIf
	Local $iChunkAtATime = 10000
	Do
		_SciTE_Send_Command(0, $Scite_hwnd, "insert:" & StringLeft($DataToInsert, $iChunkAtATime))
		Sleep(10)
		$DataToInsert = StringTrimLeft($DataToInsert, $iChunkAtATime)
	Until StringLen($DataToInsert) = 0

	Return 0
EndFunc   ;==>_InsertIntoScite

; Send command to SciTE
Func _SciTE_Send_Command($My_Hwnd, $Scite_hwnd, $sCmd)
	;----------------------------------------------------------------------------------------------
	;If $DebugIt Then _DebugPrint ('_SciTE_Send_Command-->' & $sCmd)
	;----------------------------------------------------------------------------------------------
	Local $CmdStruct = DllStructCreate('Char[' & StringLen($sCmd) + 1 & ']')
	If @error Then Return
	DllStructSetData($CmdStruct, 1, $sCmd)
	Local $COPYDATA = DllStructCreate('Ptr;DWord;Ptr')
	DllStructSetData($COPYDATA, 1, 1)
	DllStructSetData($COPYDATA, 2, StringLen($sCmd) + 1)
	DllStructSetData($COPYDATA, 3, DllStructGetPtr($CmdStruct))
	_SendMessage($Scite_hwnd, $WM_COPYDATA, $My_Hwnd, DllStructGetPtr($COPYDATA), 0, "hwnd", "ptr")
	$CmdStruct = 0
EndFunc   ;==>_SciTE_Send_Command

; Received Data from SciTE
Func _SciTE_MY_WM_COPYDATA($hWnd, $msg, $wParam, $lParam)
	#forceref $hWnd, $msg, $wParam
	Local $COPYDATA = DllStructCreate('Ptr;DWord;Ptr', $lParam)
	Local $SciTECmdLen = DllStructGetData($COPYDATA, 2)
	Local $CmdStruct = DllStructCreate('Char[' & $SciTECmdLen + 1 & ']', DllStructGetData($COPYDATA, 3))
	Local $SciTECmd = StringLeft(DllStructGetData($CmdStruct, 1), $SciTECmdLen)
	$Scite_WM_COPYDATA = $Scite_WM_COPYDATA & $SciTECmd
EndFunc   ;==>_SciTE_MY_WM_COPYDATA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Show a menu in a given GUI window which belongs to a given GUI ctrl
Func ShowMenu($hWnd, $CtrlID, $nContextID)
	Local $arPos, $x, $y
	Local $hMenu = GUICtrlGetHandle($nContextID)

	$arPos = ControlGetPos($hWnd, "", $CtrlID)

	$x = $arPos[0]
	$y = $arPos[1] + $arPos[3]

	ClientToScreen($hWnd, $x, $y)
	TrackPopupMenu($hWnd, $hMenu, $x, $y)
EndFunc   ;==>ShowMenu

; Convert the client (GUI) coordinates to screen (desktop) coordinates
Func ClientToScreen($hWnd, ByRef $x, ByRef $y)
	Local $stPoint = DllStructCreate("int;int")

	DllStructSetData($stPoint, 1, $x)
	DllStructSetData($stPoint, 2, $y)

	DllCall("user32.dll", "int", "ClientToScreen", "hwnd", $hWnd, "ptr", DllStructGetPtr($stPoint))

	$x = DllStructGetData($stPoint, 1)
	$y = DllStructGetData($stPoint, 2)
	; release Struct not really needed as it is a local
	$stPoint = 0
EndFunc   ;==>ClientToScreen

; Show at the given coordinates (x, y) the popup menu (hMenu) which belongs to a given GUI window (hWnd)
Func TrackPopupMenu($hWnd, $hMenu, $x, $y)
	DllCall("user32.dll", "int", "TrackPopupMenuEx", "hwnd", $hMenu, "int", 0, "int", $x, "int", $y, "hwnd", $hWnd, "ptr", 0)
EndFunc   ;==>TrackPopupMenu

Func _WMI_Class_AllPropertiesAndMethods(ByRef $objClass, ByRef $strClass, ByRef $aArray, $sHeadder = "")

;~ 	Local $strComputer = "."
;~ 	Local $strNameSpace = "root\cimv2"
;~ 	Local $strClass = "Win32_CodecFile"
;~ 	Local $objClass = ObjGet("winmgmts:{impersonationLevel=impersonate}!\\" & $strComputer & "\" & $strNameSpace & ":" & $strClass)

	Local $strQualifier = ""
	Local $iCount = 0

	If $sHeadder <> "" Then $strQualifier &= $sHeadder & @CRLF & @CRLF & @CRLF

	$strQualifier &= Str_Underlined($strClass & " Class Qualifiers") & @CRLF & @CRLF
	Local $i = 1, $j = 1
	For $objClassQualifier In $objClass.Qualifiers_
		$iCount += 1
		$aArray[0][0] = $iCount
		$aArray[$iCount][0] = 1
		$aArray[$iCount][1] = String($objClassQualifier.Name)
		If IsArray($objClassQualifier.Value) Then
			$aArray[$iCount][2] = Array_Join($objClassQualifier.Value)
			$strQualifier &= $i & ". " & $objClassQualifier.Name & " = " & $aArray[$iCount][2] & @CRLF
		Else
			$aArray[$iCount][2] = $objClassQualifier.Value
			$strQualifier &= $i & ". " & $objClassQualifier.Name & " = " & $aArray[$iCount][2] & @CRLF
			If $objClassQualifier.Name = "Description" Then $aArray[0][2] = $aArray[$iCount][2]
		EndIf
		$i = $i + 1
	Next
	$strQualifier &= @CRLF & @CRLF
	$strQualifier &= Str_Underlined($strClass & " Class Properties and Property Qualifiers") & @CRLF & @CRLF
	$i = 1
	$j = 1
	For $objClassProperty In $objClass.Properties_()
		$strQualifier &= $i & ". " & $objClassProperty.Name & @CRLF
		$iCount += 1
		$aArray[0][0] = $iCount
		$aArray[$iCount][0] = 2 ; Properties_
		$aArray[$iCount][1] = String($objClassProperty.Name)
		For $objPropertyQualifier In $objClassProperty.Qualifiers_()
			If IsArray($objPropertyQualifier.Value) Then
				$strQualifier &= $i & "." & $j & ". " & $objPropertyQualifier.Name & " = " & Array_Join($objPropertyQualifier.Value) & @CRLF
			Else
				$strQualifier &= $i & "." & $j & ". " & $objPropertyQualifier.Name & " = " & $objPropertyQualifier.Value & @CRLF
			EndIf
			Switch $objPropertyQualifier.Name
				Case "CIMTYPE"
					$aArray[$iCount][4] = Array_Join($objPropertyQualifier.Value, Chr(2))
				Case "ValueMap"
					$aArray[$iCount][5] = Array_Join($objPropertyQualifier.Value, Chr(2))
					$aArray[$iCount][6] = 0
					If isItAllInt($aArray[$iCount][5]) Then $aArray[$iCount][6] = 1
				Case "Values"
					$aArray[$iCount][7] = Array_Join($objPropertyQualifier.Value, Chr(2))
					$aArray[$iCount][8] = 0
					If StringInStr($aArray[$iCount][7], Chr(2)) Then $aArray[$iCount][8] = 1
			EndSwitch
			$j += 1
		Next
		$strQualifier &= @CRLF
		$i += 1
		$j = 1
	Next
	$strQualifier &= @CRLF
	$strQualifier &= Str_Underlined($strClass & " Class Methods and Method Qualifiers") & @CRLF & @CRLF
	$i = 1
	$j = 1
	For $objClassMethod In $objClass.Methods_
		$strQualifier &= $i & ". " & $objClassMethod.Name & @CRLF
		$iCount += 1
		$aArray[0][0] = $iCount
		$aArray[$iCount][0] = 3 ; Methods_
		$aArray[$iCount][1] = String($objClassMethod.Name)
		For $objMethodQualifier In $objClassMethod.Qualifiers_()
			If IsArray($objMethodQualifier.Value) Then
				$strQualifier &= $i & "." & $j & ". " & $objMethodQualifier.Name & " = " & Array_Join($objMethodQualifier.Value) & @CRLF
			Else
				$strQualifier &= $i & "." & $j & ". " & $objMethodQualifier.Name & " = " & $objMethodQualifier.Value & @CRLF
			EndIf

			Switch $objMethodQualifier.Name
				Case "CIMTYPE"
					$aArray[$iCount][4] = Array_Join($objMethodQualifier.Value, Chr(2))
				Case "ValueMap"
					$aArray[$iCount][5] = Array_Join($objMethodQualifier.Value, Chr(2))
					$aArray[$iCount][6] = 0
					If isItAllInt($aArray[$iCount][5]) Then $aArray[$iCount][6] = 1
				Case "Values"
					$aArray[$iCount][7] = Array_Join($objMethodQualifier.Value, Chr(2))
					$aArray[$iCount][8] = 0
					If StringInStr($aArray[$iCount][7], Chr(2)) Then $aArray[$iCount][8] = 1
			EndSwitch
			$j += 1
		Next
		$strQualifier &= @CRLF
		$i += 1
		$j = 1
	Next
	ReDim $aArray[$iCount + 1][30]

	Local $n = 0, $s = "", $m, $a1, $a2, $iFuncNameLen
	For $n = 1 To $aArray[0][0]
		If $aArray[$n][0] <> 2 Then ContinueLoop
		If Int($aArray[$n][6]) And Int($aArray[$n][6]) And $aArray[$n][1] <> "" Then
			$a1 = StringSplit($aArray[$n][5], Chr(2))
			$a2 = StringSplit($aArray[$n][7], Chr(2))
			If $a1[0] <> $a2[0] Then ContinueLoop
			$s = 'Func ' & $strClass & '_PropertyValues_' & $aArray[$n][1] & '( $value )' & @CRLF
			$aArray[$n][9] = $strClass & '_PropertyValues_' & $aArray[$n][1]
			$iFuncNameLen = StringLen($aArray[$n][9])
			If Int($aArray[0][4]) < $iFuncNameLen Then $aArray[0][4] = $iFuncNameLen
			If $iFuncNameLen > 60 Then
				$aArray[$n][9] = StringProperShrtn($strClass & '_PropertyValues_' & $aArray[$n][1]) ; $strClass & '__' & $n
				$s = 'Func ' & $aArray[$n][9] & '( $value )' & @CRLF & ' ; originally generated name: "' & $strClass & '_PropertyValues_' & $aArray[$n][1] & '"' & @CRLF
			EndIf
			$s &= '	Switch $value' & @CRLF
			For $m = 1 To $a1[0]
				If IsNumber($a1[$m]) Then
					$s &= '		Case ' & $a1[$m] & @CRLF
				Else
					$s &= '		Case "' & $a1[$m] & '"' & @CRLF
				EndIf
				$s &= '			Return "' & $a1[$m] & ' = ' & $a2[$m] & '"' & @CRLF
			Next
			$s &= '		Case Else' & @CRLF
			$s &= '			Return $value&" = ???"' & @CRLF
			$s &= '	EndSwitch' & @CRLF
			$s &= 'EndFunc' & @CRLF
			$aArray[$n][10] = $s
		EndIf
	Next
	For $n = 1 To $aArray[0][0]
		If $aArray[$n][0] <> 3 Then ContinueLoop
		If Int($aArray[$n][6]) And Int($aArray[$n][6]) And $aArray[$n][1] <> "" Then
			$a1 = StringSplit($aArray[$n][5], Chr(2))
			$a2 = StringSplit($aArray[$n][7], Chr(2))
			If $a1[0] <> $a2[0] Then ContinueLoop
			$s = 'Func ' & $strClass & '_MethodValues_' & $aArray[$n][1] & '( $value )' & @CRLF
			$aArray[$n][9] = $strClass & '_MethodValues_' & $aArray[$n][1]
			$iFuncNameLen = StringLen($aArray[$n][9])
			If Int($aArray[0][4]) < $iFuncNameLen Then $aArray[0][4] = $iFuncNameLen
			If $iFuncNameLen > 60 Then
				$aArray[$n][9] = StringProperShrtn($strClass & '_MethodValues_' & $aArray[$n][1]) ; $strClass & '__' & $n
				$s = 'Func ' & $aArray[$n][9] & '( $value )' & @CRLF & ' ; originally generated name: "' & $strClass & '_MethodValues_' & $aArray[$n][1] & '"' & @CRLF
			EndIf
			$s &= '	Switch $value' & @CRLF
			For $m = 1 To $a1[0]
				If IsNumber($a1[$m]) Then
					$s &= '		Case ' & $a1[$m] & @CRLF
				Else
					$s &= '		Case "' & $a1[$m] & '"' & @CRLF
				EndIf
				$s &= '			Return "' & $a1[$m] & ' = ' & $a2[$m] & '"' & @CRLF
			Next
			$s &= '		Case Else' & @CRLF
			$s &= '			Return $value&" = ???"' & @CRLF
			$s &= '	EndSwitch' & @CRLF
			$s &= 'EndFunc' & @CRLF
			$aArray[$n][10] = $s
		EndIf
	Next
	Return $strQualifier
EndFunc   ;==>_WMI_Class_AllPropertiesAndMethods

Func StringProperShrtn($s, $l = 60) ; ( string , stringLenght )

	;	Local $v = $s
	;	$v = StringReplace( $v, "a", "" )
	;	$v = StringReplace( $v, "e", "" )
	;	$v = StringReplace( $v, "i", "" )
	;	$v = StringReplace( $v, "o", "" )
	;	$v = StringReplace( $v, "u", "" )
	;	If StringLen( $v ) <= $l Then Return $v

	Local $g = 0, $x = 0, $m = 0, $n = 0, $u = "", $a = StringSplit($s, "")
	;	Local $m=StringLen($s)
	;	For $n = 1 To $a[0]
	;		If $m - $x > $l Then
	;			If StringInStr("aeiou",$a[$n]) Then
	;				$x += 1
	;				ContinueLoop
	;			EndIf
	;		EndIf
	;		$u &= $a[$n]
	;	Next
	;	If StringLen( $u ) <= $l Then Return $u

	$x = 20
	While 1
		$x -= 1
		$u = ""
		$g = 0
		For $n = 1 To $a[0]
			If $a[$n] = "_" Then
				$u &= "_"
				ContinueLoop
			EndIf
			If StringIsUpper($a[$n]) Then
				$u &= $a[$n]
				For $m = 1 To $x
					If $n + $m > $a[0] Then ExitLoop
					If StringIsUpper($a[$n + $m]) Then
						ExitLoop
					Else
						$u &= $a[$n + $m]
						If $m > $g Then $g = $m
					EndIf
				Next
			EndIf
			$u = StringReplace($u, "__", "_")
		Next
		$x = $g
		If $x = 0 Then ExitLoop
		If StringLen($u) <= $l Then ExitLoop
	WEnd
	Return $u
EndFunc   ;==>StringProperShrtn

Func Array_Join($aArray, $sSeparator = ",")
	Local $n, $sOut = ""
	If IsObj($aArray) Then
		For $value In $aArray
			$sOut &= $value & $sSeparator
		Next
		Return StringTrimRight($sOut, StringLen($sSeparator))
	Else
		For $n = 0 To UBound($aArray) - 1
			$sOut &= $aArray[$n] & $sSeparator
		Next
		Return StringTrimRight($sOut, StringLen($sSeparator))
	EndIf
EndFunc   ;==>Array_Join
Func isItAllInt($s)
	Local $n, $a = StringSplit($s, Chr(2))
	For $n = 1 To $a[0]
		If StringLen($a[$n]) > 3 Then Return 0
	Next
	Return 1
EndFunc   ;==>isItAllInt
Func Str_Underlined($s)
	Local $sOut = "", $n = 0, $i = StringLen($s)
	For $n = 1 To $i
		$sOut &= "-"
	Next
	Return $s & @CRLF & $sOut
EndFunc   ;==>Str_Underlined


;#FUNCTION# ====================================================================================================================
; Name...........: 	_iWMI_ErrorHandler
;
; Description ...: 	COM event error handler. Handles COM errors frequently thrown by erroneous WQL statements (or some statements
;					with NULL returns).
;
; Parameters ....: 	None.
;
; Return values .:	None.
;
; Remarks .......:	In the future I probably need to improve the error handling with return values.
;
; Author(s)......:	Thomas Uhrfelt
; ===============================================================================================================================
Func _iWMI_ErrorHandler()
	ConsoleWrite("Error.number: " & Hex($_iWMI_oWMIError, 8) & @CRLF)
	ConsoleWrite("Error.windescription: " & $_iWMI_oWMIError.windescription & @CRLF)
	ConsoleWrite("Error.source: " & $_iWMI_oWMIError.source & @CRLF)
	ConsoleWrite("Error.helpfile: " & $_iWMI_oWMIError.helpfile & @CRLF)
	ConsoleWrite("Error.helpcontext: " & $_iWMI_oWMIError.helpcontext & @CRLF)
	ConsoleWrite("Error.lastdllerror: " & $_iWMI_oWMIError.lastdllerror & @CRLF)
	ConsoleWrite("Error.scriptline: " & $_iWMI_oWMIError.scriptline & @CRLF)

	If $sNamespacesCombo = "" Then Return ; ..is failing because is in User mode.

	GUICtrlSetData_Sci($g_idAST_ScriptCode, "oops !" & @CRLF & @CRLF & "Error.number: " & Hex($_iWMI_oWMIError, 8) & @CRLF & _
			"Error.windescription: " & $_iWMI_oWMIError.windescription & @CRLF & @CRLF & _
			"WMI Source = " & $g_sWMISource & @CRLF)

EndFunc   ;==>_iWMI_ErrorHandler

; https://www.autoitscript.com/forum/topic/99603-resize-but-dont-get-smaller-than-original-size/#comment-714621
;Global GUIMINWID = 300, GUIMINHT = 400 ;set your restrictions here
;Global GUIMAXWID = DesktopWidth, GUIMAXHT = DesktopHeight ;
;GUIRegisterMsg($WM_GETMINMAXINFO, "WM_GETMINMAXINFO")
Func WM_GETMINMAXINFO($hWnd, $msg, $wParam, $lParam)
	Local $tagMaxinfo = DllStructCreate("int;int;int;int;int;int;int;int;int;int", $lParam)
	DllStructSetData($tagMaxinfo, 7, $GUIMINWID) ; min X
	DllStructSetData($tagMaxinfo, 8, $GUIMINHT) ; min Y
	;	DllStructSetData($tagMaxinfo, 9, $GUIMAXWID ); max X
	;	DllStructSetData($tagMaxinfo, 10, $GUIMAXHT ) ; max Y
	Return 0
EndFunc   ;==>WM_GETMINMAXINFO

Func loadRemotePCs()
	$aRemotePCs = IniReadSection($ini, "RemotePCs")
	If UBound($aRemotePCs) == 0 Then
		$gd_ComputerName = "."
		$gd_UserName = ""
		$gd_UserPassword = ""
		Dim $aRemotePCs[2][2]
		$aRemotePCs[0][0] = 1 ; total in the array
		$aRemotePCs[0][1] = 1 ; selected
		$aRemotePCs[1][0] = 1 ; ..as it would be the 1st in a list
		$aRemotePCs[1][1] = $gd_ComputerName & $iSep & $gd_UserName & $iSep & $gd_UserPassword & $iSep & 'this is the default user.' & @CRLF & '( localhost with current credentials )' & @CRLF ; value = 'PC|User|Password|Notes' ; user or domain\user
		$aRemotePCs[1][1] = $aRemotePCs[1][1] & 'ComputerName = "' & $gd_ComputerName & '"' & @CRLF
		$aRemotePCs[1][1] = $aRemotePCs[1][1] & 'UserName = "' & $gd_UserName & '"' & @CRLF
		$aRemotePCs[1][1] = $aRemotePCs[1][1] & 'UserPassword = "' & $gd_UserPassword & '"' & @CRLF
	Else
		Local $n, $a, $f = 1
		$aRemotePCs[0][1] = $aRemotePCs[1][1]
		_ArrayDelete($aRemotePCs, 1)
		$aRemotePCs[0][0] = $aRemotePCs[0][0] - 1
		For $n = 1 To $aRemotePCs[0][0]
			$aRemotePCs[$n][0] = $n
			$aRemotePCs[$n][1] = BinaryToString($aRemotePCs[$n][1])
			If StringLeft($aRemotePCs[$n][1], StringLen("." & $iSep & $iSep & $iSep)) = "." & $iSep & $iSep & $iSep Then $f = 0 ; to add a default localhost if the user removed it
		Next
		If $f Then
			$aRemotePCs[0][0] = $aRemotePCs[0][0] + 1
			ReDim $aRemotePCs[$aRemotePCs[0][0] + 1][2]
			$aRemotePCs[$aRemotePCs[0][0]][1] = "." & $iSep & $iSep & $iSep & "default for localhost" & @CRLF & "with current credentials"
		EndIf
		$a = StringSplit($aRemotePCs[$aRemotePCs[0][1]][1], $iSep, 1)
		$gd_ComputerName = $a[1]
		$gd_UserName = $a[2]
		$gd_UserPassword = $a[3]
	EndIf
EndFunc   ;==>loadRemotePCs

Func setRemotePCs($hParent = 0)
	Local $nMsg, $iPosX = -1, $iPosY = -1, $iPosW = 0, $iPosH = 0, $n, $aGUIGetCursorInfo, $iSelectedIndices
	If $hParent Then
		GUISetState(@SW_DISABLE, $hParent)
		Local $hParentPos = WinGetPos($hParent)
		$iPosX = $hParentPos[0]
		$iPosY = $hParentPos[1]
		$iPosW = $hParentPos[2]
		$iPosH = $hParentPos[3]
		$iPosX += 16
		$iPosY += 40
	EndIf
	#Region ### START Koda GUI section ### Form=ScriptOMatic.RemotePCs.kxf
	Local $rempc_Form = GUICreate("Remote PCs", 653, 504, $iPosX, $iPosY, -1, BitOR($WS_EX_TOOLWINDOW, $WS_EX_TOPMOST, $WS_EX_WINDOWEDGE), $hParent)
	Local $rempc_ListView = GUICtrlCreateListView("", 6, 6, 634, 334)
	Local $Label1 = GUICtrlCreateLabel("PC: ", 8, 352, 72, 17, $SS_RIGHT)
	Local $rempc_PC = GUICtrlCreateInput("", 80, 348, 145, 21)
	Local $Label2 = GUICtrlCreateLabel("User: ", 8, 376, 72, 17, $SS_RIGHT)
	Local $rempc_User = GUICtrlCreateInput("", 80, 372, 145, 21)
	Local $Label3 = GUICtrlCreateLabel("Password: ", 8, 400, 72, 17, $SS_RIGHT)
	Local $rempc_Pass = GUICtrlCreateInput("", 80, 396, 145, 21)
	Local $Label4 = GUICtrlCreateLabel("Notes: ", 281, 346, 72, 17, $SS_RIGHT)
	Local $rempc_Notes = GUICtrlCreateEdit("", 232, 365, 409, 121)
	Local $rempc_Add = GUICtrlCreateButton("Add", 8, 427, 59, 23)
	Local $rempc_Update = GUICtrlCreateButton("Update", 80, 427, 59, 23)
	Local $rempc_Remove = GUICtrlCreateButton("Remove", 152, 427, 59, 23)
	Local $rempc_SaveToDisk = GUICtrlCreateButton("Save to disk", 17, 468, 179, 23)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###

	GUICtrlSetFont($rempc_PC, 10, 400, 0, "Verdana")
	GUICtrlSetFont($rempc_User, 10, 400, 0, "Verdana")
	GUICtrlSetFont($rempc_Pass, 10, 400, 0, "Verdana")
	GUICtrlSetFont($rempc_Notes, 10, 400, 0, "Verdana")

	Local $iAccelKey_ESC = GUICtrlCreateButton("Exit", 1, 2, 3, 2, $BS_NOTIFY)
	GUICtrlSetState($iAccelKey_ESC, $GUI_HIDE)
	Local $aAccelKeys[1][2] = [["{ESC}", $iAccelKey_ESC]]
	GUISetAccelerators($aAccelKeys)

	_GUICtrlListView_AddColumn($rempc_ListView, "PC", 180)
	_GUICtrlListView_AddColumn($rempc_ListView, "Domain\User or User", 200)
	_GUICtrlListView_AddColumn($rempc_ListView, "Password", 180)
	_GUICtrlListView_AddColumn($rempc_ListView, "Notes", 180)
	Local $toRestoreGUIDataSeparatorChar = Opt("GUIDataSeparatorChar", $iSep)
	For $n = 1 To $aRemotePCs[0][0]
		$aRemotePCs[$n][0] = GUICtrlCreateListViewItem($aRemotePCs[$n][1], $rempc_ListView)
	Next
	_GUICtrlListView_SetItemSelected($rempc_ListView, $aRemotePCs[0][1] - 1)
	GUICtrlSetData($rempc_PC, _GUICtrlListView_GetItemText($rempc_ListView, $aRemotePCs[0][1] - 1, 0))
	GUICtrlSetData($rempc_User, _GUICtrlListView_GetItemText($rempc_ListView, $aRemotePCs[0][1] - 1, 1))
	GUICtrlSetData($rempc_Pass, _GUICtrlListView_GetItemText($rempc_ListView, $aRemotePCs[0][1] - 1, 2))
	GUICtrlSetData($rempc_Notes, _GUICtrlListView_GetItemText($rempc_ListView, $aRemotePCs[0][1] - 1, 3))
	ReDim $aRemotePCs[$aRemotePCs[0][0] + 1000][2] ; preallocate to easily add / remove entries, 1000 extra should be more than enough

	If $aRemotePCs[0][0] < 2 Then
		GUICtrlSetState($rempc_Update, $GUI_DISABLE)
		GUICtrlSetState($rempc_Remove, $GUI_DISABLE)
	EndIf

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE, $iAccelKey_ESC
				ExitLoop
			Case $GUI_EVENT_PRIMARYUP
				$aGUIGetCursorInfo = GUIGetCursorInfo($rempc_Form)
				If UBound($aGUIGetCursorInfo) < 5 Then ContinueLoop
				If $aGUIGetCursorInfo[4] = $rempc_ListView Then
					$iSelectedIndices = _GUICtrlListView_GetSelectedIndices($rempc_ListView)
					If $iSelectedIndices = "" Then
						GUICtrlSetState($rempc_Update, $GUI_DISABLE)
						GUICtrlSetState($rempc_Remove, $GUI_DISABLE)
						GUICtrlSetData($rempc_PC, "")
						GUICtrlSetData($rempc_User, "")
						GUICtrlSetData($rempc_Pass, "")
						GUICtrlSetData($rempc_Notes, "")
					Else
						$iSelectedIndices = Int($iSelectedIndices)
						$aRemotePCs[0][1] = $iSelectedIndices + 1
						GUICtrlSetData($rempc_PC, _GUICtrlListView_GetItemText($rempc_ListView, $iSelectedIndices, 0))
						GUICtrlSetData($rempc_User, _GUICtrlListView_GetItemText($rempc_ListView, $iSelectedIndices, 1))
						GUICtrlSetData($rempc_Pass, _GUICtrlListView_GetItemText($rempc_ListView, $iSelectedIndices, 2))
						GUICtrlSetData($rempc_Notes, _GUICtrlListView_GetItemText($rempc_ListView, $iSelectedIndices, 3))
						If $aRemotePCs[0][0] > 1 Then
							GUICtrlSetState($rempc_Update, $GUI_ENABLE)
							GUICtrlSetState($rempc_Remove, $GUI_ENABLE)
						EndIf
					EndIf
				EndIf

			Case $rempc_Add
				GUICtrlSetState($rempc_Add, $GUI_DISABLE)
				$aRemotePCs[0][0] = $aRemotePCs[0][0] + 1
				$aRemotePCs[0][1] = $aRemotePCs[0][0]
				$iSelectedIndices = $aRemotePCs[0][1] - 1
				$aRemotePCs[$aRemotePCs[0][1]][1] = GUICtrlRead($rempc_PC) & $iSep & GUICtrlRead($rempc_User) & $iSep & GUICtrlRead($rempc_Pass) & $iSep & GUICtrlRead($rempc_Notes)
				$aRemotePCs[$aRemotePCs[0][1]][0] = GUICtrlCreateListViewItem($aRemotePCs[$aRemotePCs[0][1]][1], $rempc_ListView)
				$iSelectedIndices = $aRemotePCs[0][1] - 1
				_GUICtrlListView_SetItemSelected($rempc_ListView, $iSelectedIndices)
				If $aRemotePCs[0][0] > 1 Then
					GUICtrlSetState($rempc_Update, $GUI_ENABLE)
					GUICtrlSetState($rempc_Remove, $GUI_ENABLE)
				EndIf
				Sleep(200)
				GUICtrlSetState($rempc_Add, $GUI_ENABLE)

			Case $rempc_Update
				GUICtrlSetState($rempc_Update, $GUI_DISABLE)
				$aRemotePCs[$aRemotePCs[0][1]][1] = GUICtrlRead($rempc_PC) & $iSep & GUICtrlRead($rempc_User) & $iSep & GUICtrlRead($rempc_Pass) & $iSep & GUICtrlRead($rempc_Notes)
				GUICtrlSetData($aRemotePCs[$aRemotePCs[0][1]][0], $aRemotePCs[$aRemotePCs[0][0]][1])
				Sleep(200)
				GUICtrlSetState($rempc_Update, $GUI_ENABLE)

			Case $rempc_Remove
				GUICtrlSetState($rempc_Remove, $GUI_DISABLE)
				GUICtrlDelete($aRemotePCs[$aRemotePCs[0][1]][0])
				_ArrayDelete($aRemotePCs, $aRemotePCs[0][1])
				$aRemotePCs[0][0] = $aRemotePCs[0][0] - 1
				$aRemotePCs[0][1] = $aRemotePCs[0][1] - 1
				If Not $aRemotePCs[0][1] Then $aRemotePCs[0][1] = 1
				If $aRemotePCs[0][0] < 2 Then
					GUICtrlSetState($rempc_Update, $GUI_DISABLE)
				Else
					Sleep(200)
					GUICtrlSetState($rempc_Remove, $GUI_ENABLE)
				EndIf
				ConsoleWrite(@ScriptLineNumber & " @ " & $aRemotePCs[0][1] & @CRLF)
				$iSelectedIndices = $aRemotePCs[0][1] - 1
				_GUICtrlListView_SetItemSelected($rempc_ListView, $iSelectedIndices)
				GUICtrlSetData($rempc_PC, _GUICtrlListView_GetItemText($rempc_ListView, $iSelectedIndices, 0))
				GUICtrlSetData($rempc_User, _GUICtrlListView_GetItemText($rempc_ListView, $iSelectedIndices, 1))
				GUICtrlSetData($rempc_Pass, _GUICtrlListView_GetItemText($rempc_ListView, $iSelectedIndices, 2))
				GUICtrlSetData($rempc_Notes, _GUICtrlListView_GetItemText($rempc_ListView, $iSelectedIndices, 3))

			Case $rempc_SaveToDisk
				GUICtrlSetState($rempc_SaveToDisk, $GUI_DISABLE)
				IniDelete($ini, "RemotePCs")
				IniWrite($ini, "RemotePCs", 0, $aRemotePCs[0][1])
				For $n = 1 To $aRemotePCs[0][0]
					IniWrite($ini, "RemotePCs", $n, StringToBinary($aRemotePCs[$n][1]))
				Next
				Sleep(200)
				GUICtrlSetState($rempc_SaveToDisk, $GUI_ENABLE)
		EndSwitch
	WEnd
	GUIDelete($rempc_Form)
	Opt("GUIDataSeparatorChar", $toRestoreGUIDataSeparatorChar)
	ReDim $aRemotePCs[$aRemotePCs[0][0] + 1][2]
	Local $a = StringSplit($aRemotePCs[$aRemotePCs[0][1]][1], $iSep, 1)
	$gd_ComputerName = $a[1]
	$gd_UserName = $a[2]
	$gd_UserPassword = $a[3]
	If $hParent Then
		GUISetState(@SW_ENABLE, $hParent)
		WinActivate($hParent)
	EndIf
	While GUIGetMsg() ; to clear any leftover clicking
	WEnd
EndFunc   ;==>setRemotePCs

Func Func_nice_COMerrorHandler($TAB = '   ')
	Local $sOut = "" & @CRLF
	$sOut &= 'Func _nice_COMerrorHandler($i = 0)' & @CRLF
	$sOut &= $TAB & 'If $i == 1 Then' & @CRLF
	$sOut &= $TAB & $TAB & 'Dim $_nice_COMerrorArray[301][9]' & @CRLF
	$sOut &= $TAB & $TAB & '$_nice_COMerrorArray[0][0] = 0' & @CRLF
	$sOut &= $TAB & $TAB & '$_nice_COMerrorObj = ObjEvent("AutoIt.Error", "_nice_COMerrorHandler")' & @CRLF
	$sOut &= $TAB & $TAB & 'Return' & @CRLF
	$sOut &= $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & 'If $i == 2 Then' & @CRLF
	$sOut &= $TAB & $TAB & 'If Not @Compiled Then' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'Local $n = 0, $c = 0, $s = FileRead(@ScriptFullPath)' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'Local $a = StringSplit($s, @CRLF, 1)' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'For $n = 1 To $_nice_COMerrorArray[0][0]' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'If Int($_nice_COMerrorArray[$n][7]) > $a[0] Then ContinueLoop' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & '$_nice_COMerrorArray[$n][8] = StringStripWS($a[Int($_nice_COMerrorArray[$n][7])], 3)' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'If StringInStr($s, "; only for the ANSI compiled version" & @CRLF) Then' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'For $n = 1 To $a[0]' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & 'If StringInStr($a[$n], "; only for the ANSI compiled version") Then $c += 1' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & 'If $n > 50 Then ExitLoop' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'For $n = 1 To $_nice_COMerrorArray[0][0]' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & $TAB & '$_nice_COMerrorArray[$n][7] = $_nice_COMerrorArray[$n][7] - $c' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & $TAB & 'Next' & @CRLF
	$sOut &= $TAB & $TAB & $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & $TAB & '$_nice_COMerrorArray[1][0] = ""' & @CRLF
	$sOut &= $TAB & $TAB & 'ReDim $_nice_COMerrorArray[$_nice_COMerrorArray[0][0] + 1][9]' & @CRLF
	$sOut &= $TAB & $TAB & '_ArrayDisplay($_nice_COMerrorArray, "ScriptOMatic - COM Errors intercepted ( the script will continue after this screen )")' & @CRLF
	$sOut &= $TAB & $TAB & 'Return' & @CRLF
	$sOut &= $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & 'If $_nice_COMerrorArray[0][0] = 300 Then' & @CRLF
	$sOut &= $TAB & $TAB & '$_nice_COMerrorArray[0][8] = "ScriptLine: only first 300 errors shown !!!"' & @CRLF
	$sOut &= $TAB & $TAB & 'Return' & @CRLF
	$sOut &= $TAB & 'EndIf' & @CRLF
	$sOut &= $TAB & 'If StringInStr($_nice_COMerrorArray[1][0], "|" & $_nice_COMerrorObj.scriptline & "|") Then Return' & @CRLF
	$sOut &= $TAB & '$i = $_nice_COMerrorArray[0][0] + 1' & @CRLF
	$sOut &= $TAB & '$_nice_COMerrorArray[0][0] = $i' & @CRLF
	$sOut &= $TAB & '$_nice_COMerrorArray[$i][1] = "0x" & Hex($_nice_COMerrorObj, 8)' & @CRLF
	$sOut &= $TAB & '$_nice_COMerrorArray[$i][2] = $_nice_COMerrorObj.windescription' & @CRLF
	$sOut &= $TAB & '$_nice_COMerrorArray[$i][3] = $_nice_COMerrorObj.source' & @CRLF
	$sOut &= $TAB & '$_nice_COMerrorArray[$i][4] = $_nice_COMerrorObj.helpfile' & @CRLF
	$sOut &= $TAB & '$_nice_COMerrorArray[$i][5] = $_nice_COMerrorObj.helpcontext' & @CRLF
	$sOut &= $TAB & '$_nice_COMerrorArray[$i][6] = $_nice_COMerrorObj.lastdllerror' & @CRLF
	$sOut &= $TAB & '$_nice_COMerrorArray[$i][7] = $_nice_COMerrorObj.scriptline' & @CRLF
	$sOut &= $TAB & '$_nice_COMerrorArray[1][0] = $_nice_COMerrorArray[1][0] & "|" & $_nice_COMerrorObj.scriptline & "|"' & @CRLF
	$sOut &= $TAB & 'If $i == 1 Then' & @CRLF
	$sOut &= $TAB & $TAB & '$_nice_COMerrorArray[0][1] = "ErrorNumber:"' & @CRLF
	$sOut &= $TAB & $TAB & '$_nice_COMerrorArray[0][2] = "WinDescription:"' & @CRLF
	$sOut &= $TAB & $TAB & '$_nice_COMerrorArray[0][3] = "Source:"' & @CRLF
	$sOut &= $TAB & $TAB & '$_nice_COMerrorArray[0][4] = "HelpFile:"' & @CRLF
	$sOut &= $TAB & $TAB & '$_nice_COMerrorArray[0][5] = "HelpContext:"' & @CRLF
	$sOut &= $TAB & $TAB & '$_nice_COMerrorArray[0][6] = "LastDLLerror:"' & @CRLF
	$sOut &= $TAB & $TAB & '$_nice_COMerrorArray[0][7] = "ScriptLineNumber:"' & @CRLF
	$sOut &= $TAB & $TAB & '$_nice_COMerrorArray[0][8] = "ScriptLine:"' & @CRLF
	$sOut &= $TAB & 'EndIf' & @CRLF
	$sOut &= 'EndFunc   ;==>_nice_COMerrorHandler' & @CRLF
	Return $sOut
EndFunc   ;==>Func_nice_COMerrorHandler

Func getSelfVersionForTitle()
	If @Compiled Then
		Local $sVersion = FileGetVersion(@ScriptFullPath)
	Else
		Local $s = FileRead(@ScriptFullPath, 4096)
		Local $i = StringInStr($s, "#AutoIt3Wrapper_Res_Fileversion=")
		Local $i2 = StringInStr($s, @CRLF, 0, 1, $i)
		$s = StringLeft($s, $i2)
		$sVersion = StringTrimLeft($s, $i + 33)
	EndIf
	Local $a = StringSplit($sVersion, ".")
	If UBound($a) = 5 Then Return StringRight("0000" & $a[2], 4) & "." & StringRight("00" & $a[3], 2) & "." & StringRight("00" & $a[4], 2)
	Return $sVersion
EndFunc   ;==>getSelfVersionForTitle
